AJS.$(document).ready(function() {
    var $activeFrxTreeLI;
    var $activeFrxControl;
    // Edit-content in manage files
    AJS.$('#edit-content-container a.scroll-to-frx').live('click', function() {
        var frxId = AJS.$(this).attr('id').replace(/scroll-to-frx/, '');

        if ($activeFrxTreeLI) {
            $activeFrxTreeLI.removeClass("activeFrx");
        }
        if ($activeFrxControl) {
            $activeFrxControl.hide();
        }
        $activeFrxTreeLI  = AJS.$("#frx-list-item" + frxId).addClass("activeFrx");
        $activeFrxControl = AJS.$("#frxControlsContainer" + frxId).show();

        if ($activeFrxControl.hasClass("autoShowDiffForm")) {
            $activeFrxControl.removeClass("autoShowDiffForm");
            showDiffForm(frxId);
        }
    });

    AJS.CRU.CREATE.removeActiveFrx = function () {
        if ($activeFrxTreeLI) {
            $activeFrxTreeLI.removeClass("activeFrx");
        }
        if ($activeFrxControl) {
            $activeFrxControl.hide();
        }
    };

    AJS.$('button.removeFrx').live('click', function () {
        var $button = AJS.$(this);
        $button.attr('disabled', true);
        var idBits = $button.attr('id').split('-');
        AJS.CRU.CREATE.addRevisionFromView('remove', idBits[1], idBits[2]);
        return false;
    });

    AJS.$('.frxSlider .deleteRev').live('click', function () {
        var $x = AJS.$(this);
        var idBits = $x.attr('id').split('-');
        AJS.FECRU.AJAX.startSpin($x, false, 'span');
        $x.hide();
        AJS.CRU.CREATE.addRevisionFromView('removeRevisions', idBits[1], idBits[2], function () {
            AJS.FECRU.AJAX.stopSpin($x[0], 'span');
            $x.show();
        });
    });

    AJS.$('.addRevision').live('click', function () {
        var $elem = AJS.$(this);
        var revId = $elem.attr('id').replace(/^addRev/, '');
        AJS.CRU.CREATE.addRevisionToIter(revId); 
    });

    AJS.$('.removeRevision').live('click', function () {
        var $elem = AJS.$(this);
        var revId = $elem.attr('id').replace(/^remRev/, '');
        AJS.CRU.CREATE.removeRevisionFromIter(revId);
    });

    AJS.$('.addChangeSet').live('click', function () {
        var $elem = AJS.$(this);
        var csId = $elem.attr('id').replace(/^(addCs|containsSome)/, '');
        AJS.CRU.CREATE.addChangesetToIter(csId);
    });

    AJS.$('.removeChangeSet').live('click', function () {
        var $elem = AJS.$(this);
        var csId = $elem.attr('id').replace(/^remCs|removeSomeCs/, '');
        AJS.CRU.CREATE.removeChangesetFromIter(csId);
    });

    AJS.$('.changeDiffAddRevision').live('click', function () {
        var $elem = AJS.$(this);
        var frxId = $elem.attr('id').replace(/^changeDiffAddRevision/, '');
        var revId = AJS.$('#changeDiffSelect').val();
        $elem.attr('disabled', true);
        AJS.FECRU.AJAX.startSpin($elem, false, 'span');
        var done = function () {
            $elem.attr('disabled', false);
            AJS.FECRU.AJAX.stopSpin($elem[0], 'span');
        };
        AJS.CRU.CREATE.addRevisionFromView('add', frxId, revId, done);
    });

    // Edit Revisions inline dialog.
    AJS.InlineDialog(
        '.updateFrxFromFormToggle button',
        'edit-revisions-inline-dialog-form',
        function ($container, $this, showPopup) {
            var frxId = $this.closest('.updateFrxFromFormToggle').attr('id').replace('updateFrxFromFormToggle', '');
            var $formSpan = AJS.$('#updateFrxFromFormSpan' + frxId);

            if (!$formSpan.is('.allocated')) {
                var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/changeDiffDropdownAjax/";
                var params = { frxId: frxId };
                AJS.FECRU.AJAX.startSpin('updateFrxFromFormToggle' + frxId, false, "span", "");

                AJS.FECRU.AJAX.ajaxDo(url, params, function(resp) {
                    AJS.FECRU.AJAX.stopSpin(AJS.$('#updateFrxFromFormToggle' + frxId)[0], 'span');
                    if (resp.worked) {
                        // Enable the delete revision markers.
                        AJS.$('#frxSliderDiv-' + frxId + ' .deleteRev-hidden')
                            .removeClass("deleteRev-hidden")
                            .addClass("deleteRev-shown");

                        $formSpan
                            .html(resp.msgHtml)
                            .addClass('allocated');

                        $container.html($formSpan.show());
                        showPopup();
                    }
                });
            } else {
                $container.html($formSpan.show());
                showPopup();
            }
        },
        {
            hideDelay: 200,
            width: 600,
            offsetY: 2,
            cacheContent: false,
            initCallback: function () {
                var inlineDialog = this;
                AJS.$(document).bind('frx-deactive.edit-revisions', function () {
                    inlineDialog.hide();
                });
                inlineDialog.popup.find('.close').bind('click.edit-revisions', function () {
                    inlineDialog.hide();
                });
            },
            hideCallback: function () {
                AJS.$(document).unbind('frx-deactive.edit-revisions');
                var $popup = this.popup;
                $popup.find('.close').unbind('click.edit-revisions');
                // Stash the form span away for the next time we need to show it.
                $popup.find('.updateFrxFromFormSpan')
                    .hide()
                    .remove()
                    .appendTo('body');
            }
        }
    );

});
