if (AJS.CRU === undefined) {
    AJS.CRU = {};
}
AJS.CRU.CREATE = {};

(function() {
    AJS.CRU.CREATE.changesets = {}; // map of csid -> array of revids
    AJS.CRU.CREATE.revid2csid = {};
    AJS.CRU.CREATE.revidsInIteration = {};
    AJS.CRU.CREATE.repnameInUse = "";

    AJS.CRU.CREATE.addLatestRevision = function (frxId, revid) {
        var done = function (resp) {
            if (resp.worked) {
                AJS.$("#frx-outdated"+frxId).hide();
            }
        };
        return AJS.CRU.CREATE.addRevisionFromView('add', frxId, revid, done);
    };

    AJS.CRU.CREATE.addRevisionFromView = function (command, frxId, revid, done) {
        var params = {
            "revid" : revid,
            "command" : command,
            "frxId" : frxId,
            "attachMethod" : "iterative"
        };
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/editRevisionsFromRevisionAjax/";

        var frxOuterId = 'frxouter' + frxId;
        var oldInnerHTML = AJS.$("#"+frxOuterId).html();

        AJS.CRU.FRX.dimFrx(frxId);
        var onComp = function(resp) {
            if (!resp.worked) {
                // if the request didn't work, make sure the spinner
                // is taken out, and the old text restored.
                AJS.$("#"+frxOuterId).html(oldInnerHTML);
            } else {
                if (resp.frxExists) {
                    var frxAjax = AJS.CRU.FRX.AJAX;
                    frxAjax.reloadFrxModel(frxId, resp, false);
                    frxAjax.updateFrxSlider(frxId, resp);
                    frxAjax.updateFrxDiffControls(frxId, resp);
                } else {
                    //remove frx
                    var frx = review.frx(frxId);
                    review.removeFrx(frx);
                    AJS.$('#' + frxOuterId).remove();
                    var $toRemove = AJS.$('#frx-list-item' + frxId);
                    while ($toRemove.hasClass('frx-list-item') && $toRemove.siblings().length === 0) {
                        $toRemove = $toRemove.parent().parent();
                    }
                    //get next frx to select
                    var $selectNext = $toRemove.next().find('.frx').filter(':first');
                    if ($toRemove) {
                        $toRemove.remove();
                    }
                    if ($selectNext.length !== 1) {
                        $selectNext = AJS.$('#navigation-tree .frx').filter(':last');
                    }
                    if ($selectNext.length !== 1) {
                        AJS.CRU.CREATE.removeActiveFrx();
                        AJS.$('#scroll-to-general-comments').click();
                        AJS.$('#frx-pane').scrollTo(AJS.$('#generalComments'));
                    } else {
                        $selectNext.find('.scroll-to-frx').click();
                        var newfrxId = $selectNext.find('.scroll-to-frx').attr('id').split('scroll-to-frx')[1];
                        AJS.$('#frx-pane').scrollTo(AJS.$('#frxouter'+newfrxId));
                    }

                    commentScrollTracker.rescan();
                    AJS.CRU.FRX.scroller.rescan();
                }
            }
            if (done) {
                done({worked: resp.worked});
            }
        };
        AJS.FECRU.AJAX.ajaxUpdate(url, params, frxOuterId, onComp);
        return false;
    };

    var addRemoveRevisionToIter = function (add, revid) {
        var busyid = "busyRev" + revid;
        var nochangeid = "";
        var $revPath = AJS.$("#revPath" + revid);
        toggleNodeAndImage(busyid, true, false, true);
        if (add) {
            toggleNodeAndImage("addRev" + revid, false, true, true);
            nochangeid = "addRev" + revid;
            $revPath.css("textDecoration","");
        } else {
            toggleNodeAndImage("remRev" + revid, false, true, true);
            nochangeid = "remRev" + revid;
            $revPath.css("textDecoration","line-through");
        }
        var params = {
            "revid" : revid,
            "command" : add ? "add" : "remove",
            "attachMethod" : AJS.$("#attachMethod").val(),
            "fromRevision" : AJS.$("#fromRevision").val()
        };
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/editRevisionsAjax/";

        return doAddRemoveCall(url, params, busyid, nochangeid);
    };

    AJS.CRU.CREATE.addRevisionToIter = function (revid) {
        addRemoveRevisionToIter(true, revid);
    };

    AJS.CRU.CREATE.removeRevisionFromIter = function (revid) {
        addRemoveRevisionToIter(false, revid);
    };

    AJS.CRU.CREATE.addAllSearchRevisions = function (url) {
        AJS.$('#addAllBusy').css('display','inline');
        url += "&command=addSearch";
        url += "&search=" + AJS.$("#qlStr").val();
        url += "&spage=" + AJS.$("#results.thisPageNum").val();
        url += "&attachMethod=" + AJS.$("#attachMethod").val();
        url += "&fromRevision=" + AJS.$("#fromRevision").val();
        window.location=url;
    };

    var doAddMultipleCall = function (url, params) {
        var done = function(resp) {
            if (!resp.worked || AJS.FECRU.AJAX.checkError(resp)) {
                return false;
            }
            updateRespMsgBusy(resp.msgHtml);

            var updatedChangesets = {};

            AJS.$.each(resp.addedRevids, function() {
                var addedRevid = this;
                updatedChangesets[AJS.CRU.CREATE.revid2csid[addedRevid]] = 1;
                AJS.CRU.CREATE.revidsInIteration[addedRevid] = 1;
                toggleNodeAndImage("addRev" + addedRevid, false, true, true);
                toggleNodeAndImage("remRev" + addedRevid, true, false, true);
            });
            for (var csid in updatedChangesets) {
                updateChangesetAddRemove(csid);
            }
        };

        AJS.$.post(url, params, done, "json");
    };

    AJS.CRU.CREATE.addRevisionsToIter = function (permaId, revIdArray) {
        AJS.$.each(revIdArray, function() {
            AJS.$("#revPath" + this).css("textDecoration","");
        } );
        var params = {
            "revid" : revIdArray,
            "command" : "add",
            "attachMethod" : AJS.$("#attachMethod").val(),
            "fromRevision" : AJS.$("#fromRevision").val()
        };
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/editRevisionsAjax/";

        return doAddMultipleCall(url, params);
    };


    var doAddRemoveCall = function (url, params, busyid, nochangeid) {
        var done = function(resp) {
            if (!resp.worked || AJS.FECRU.AJAX.checkError(resp)) {
                toggleNodeAndImage(busyid, false, true, true);
                toggleNodeAndImage(nochangeid, true, false, true);
                return false;
            }
            updateRespMsgBusy(resp.msgHtml);

            var updatedChangesets = {};

            toggleNodeAndImage(busyid, false, true, true);
            toggleNodeAndImage(nochangeid, true, false, true);

            AJS.$.each(resp.addedRevids, function() {
                updatedChangesets[AJS.CRU.CREATE.revid2csid[this]] = 1;
                AJS.CRU.CREATE.revidsInIteration[this] = 1;
                toggleNodeAndImage("addRev" + this, false, true, true);
                toggleNodeAndImage("remRev" + this, true, false, true);
            } );
            AJS.$.each(resp.removedRevids, function() {
                updatedChangesets[AJS.CRU.CREATE.revid2csid[this]] = 1;
                AJS.CRU.CREATE.revidsInIteration[this] = 0;
                toggleNodeAndImage("addRev" + this, true, false, true);
                toggleNodeAndImage("remRev" + this, false, true, true);
            } );

            for (var csid in updatedChangesets) {
                updateChangesetAddRemove(csid);
            }
        };

        AJS.$.post(url, params, done, "json");
    };

    var updateChangesetAddRemove = function (csid) {
        var revids = AJS.CRU.CREATE.changesets[csid];
        if (!revids) {
            return;
        }
        var inCount = 0;
        AJS.$.each(revids, function() {
            if (AJS.CRU.CREATE.revidsInIteration[this] == 1) {
                inCount++;
            }
        } );
        var showAdd = inCount < revids.length;
        var showRemove = inCount > 0;
        var showSome = showAdd && showRemove;
        if (showSome) {
            showAdd = false;
            showRemove = false;
        }
        toggleNodeAndImage("addCs" + csid, showAdd, !showAdd, true);
        toggleNodeAndImage("remCs" + csid, showRemove, !showRemove, true);
        toggleNodeAndImage("containsSome" + csid, showSome, !showSome, true);
    };

    AJS.CRU.CREATE.addChangesetToIter = function (csid) {
        addRemoveChangesetToIter(true, csid);
    };

    AJS.CRU.CREATE.removeChangesetFromIter = function (csid) {
        addRemoveChangesetToIter(false, csid);
    };

    var addRemoveChangesetToIter = function (add, csid) {
        var busyid = "busyCs" + csid;
        var nochangeid = "";
        if (!add) {
            nochangeid = "remCs" + csid;
        } else if (AJS.$("#addCs" + csid).is(":hidden")) {
            nochangeid = "containsSome" + csid;
        } else {
            nochangeid = "addCs" + csid;
        }
        toggleNodeAndImage(nochangeid, false, true, true);
        toggleNodeAndImage(busyid, true, false, true);

        var params = {
            "csid" : csid,
            "command" : add ? "add" : "remove",
            "sourceName" : AJS.CRU.CREATE.repnameInUse,
            "attachMethod" : AJS.$("#attachMethod").val(),
            "fromRevision" : AJS.$("#fromRevision").val()
        };

        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + '/editRevisionsAjax/';

        doAddRemoveCall(url, params, busyid, nochangeid);
    };

    AJS.CRU.CREATE.removeAllRevs = function () {
        var pars = 'command=removeAll&sourceName=' + AJS.CRU.CREATE.repnameInUse;
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + '/editRevisionsAjax/';
        doAddRemoveCall(url, pars);
    };

    AJS.CRU.CREATE.addSearchFileRevToReview = function (revisionId, repName) {
        addRemoveRevisionToIter(true, revisionId, repName);
    };

    AJS.CRU.CREATE.removeSearchFileRevToReview = function (revisionId, repName) {
        addRemoveRevisionToIter(false, revisionId, repName);
    };

    AJS.CRU.CREATE.dirListRevs = [];

    //this is for the file browse tab
    AJS.CRU.CREATE.addFileRevisionToReview = function (latestRevId) {
        var newSelectedRevId = document.forms["selectRevisionForm" + latestRevId].revId.value;
        addRemoveFileRevisionReview(true, newSelectedRevId, latestRevId);
    };

    AJS.CRU.CREATE.removeFileRevisionFromReview = function (latestRevId) {
        var newSelectedRevId = document.forms["selectRevisionForm" + latestRevId].revId.value;
        addRemoveFileRevisionReview(false, newSelectedRevId, latestRevId);
    };

    var addRemoveFileRevisionReview = function (add, revid, latestRevId, onEval) {
        var busyid = "busyRev" + latestRevId;
        var nochangeid = "";
        toggleNodeAndImage(busyid, true, false, true);
        if (add) {
            toggleNodeAndImage("addRev" + latestRevId, false, true, true);
            nochangeid = "addRev" + latestRevId;
        } else {
            toggleNodeAndImage("remRev" + latestRevId, false, true, true);
            nochangeid = "remRev" + latestRevId;
        }

        var params = {
            "revid" : revid,
            "command" : add ? "add" : "remove",
            "attachMethod" : AJS.$("#attachMethod").val(),
            "fromRevision" : AJS.$("#fromRevision").val()
        };
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + '/editRevisionsAjax/';

        return doAddRemoveFRCall(url, params, busyid, nochangeid, latestRevId, onEval);
    };

    var doAddRemoveFRCall = function (url, params, busyid, nochangeid, latestRevId, onEval) {
        var done = function(resp) {
            try {
                // take out the spinner image regardless of what the response is
                toggleNodeAndImage(busyid, false, true, true);
                toggleNodeAndImage(nochangeid, true, false, true);
                if (!resp.worked || AJS.FECRU.AJAX.checkError(resp)) {
                    return false;
                }
                updateRespMsgBusy(resp.msgHtml);
                //todo fix this looks wrong
                for (var i = 0; i < resp.removedRevids.length; i++) {
                    AJS.CRU.CREATE.dirListRevs[latestRevId] = "";
                    toggleNodeAndImage("addRev" + latestRevId, true, false, true);
                    toggleNodeAndImage("remRev" + latestRevId, false, true, true);
                }
                for (i = 0; i < resp.addedRevids.length; i++) {
                    AJS.CRU.CREATE.dirListRevs[latestRevId] = resp.addedRevids[i];
                    toggleNodeAndImage("addRev" + latestRevId, false, true, true);
                    toggleNodeAndImage("remRev" + latestRevId, true, false, true);
                }
                if (onEval) {
                    onEval();
                }
            } catch (error) {
                window.alert(error);
            }
        };

        AJS.$.post(url, params, done, "json");
    };

    var loadFullHistoryDropdown = function (latestRevId) {
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + '/loadFullHistoryDropdownAjax/';
        var params = { "latestRevId" : latestRevId };
        var elementIdToUpdate = "selectDiff" + latestRevId;

        return AJS.FECRU.AJAX.ajaxUpdate(url, params, elementIdToUpdate);
    };

    AJS.CRU.CREATE.updateSelectedRev = function (latestRevId) {
        var selectBox = document.forms["selectRevisionForm" + latestRevId].revId;
        var formval = selectBox.value;
        if (formval == "__LOADFULL__") {
            AJS.FECRU.AJAX.startSpin(selectBox, true, "span");
            loadFullHistoryDropdown(latestRevId);
            return;
        }
        var onEval = function() {
            addRemoveFileRevisionReview(true, formval, latestRevId );
        };
        addRemoveFileRevisionReview(false, AJS.CRU.CREATE.dirListRevs[latestRevId], latestRevId, onEval);
    };

    /* patch file revision functions */
    AJS.CRU.CREATE.patches = [];
    AJS.CRU.CREATE.patchesInc = [];
    AJS.CRU.CREATE.patchRevs = [];
    AJS.CRU.CREATE.incPatchRevs = [];

    AJS.CRU.CREATE.addAllPatch = function (sourceName) {
        addRemoveAllPatch(true, sourceName); //todo fix me PATCH: is a kludge
    };

    AJS.CRU.CREATE.removeAllPatch = function (sourceName) {
        addRemoveAllPatch(false, sourceName); //todo fix me PATCH: is a kludge
    };

    // must match Source.SEPARATOR
    AJS.CRU.CREATE.SOURCE_SEPARATOR = ":";

    var addRemoveAllPatch = function (add, sourceName) {
        var patchID = sourceName.split(AJS.CRU.CREATE.SOURCE_SEPARATOR)[1];
        var incRevs = AJS.CRU.CREATE.patchesInc[sourceName];
        var revs = AJS.CRU.CREATE.patches[sourceName];
        AJS.$("#addAll" + patchID).hide();
        AJS.$("#remAll" + patchID).hide();
        AJS.$("#containsSome" + patchID).hide();
        AJS.$("#busy" + patchID).show();

        var params = {
            "revid" : AJS.CRU.CREATE.patches[sourceName],
            "command" : add ? "add" : "remove"
        };

        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + '/editRevisionsAjax/';

        var done = function(resp) {
            var remRev = function(revId) {
                incRevs[revId] = "";
            };
            var addRev = function(revId) {
                incRevs[revId] = revId;
            };
            updateRespMsgBusy(resp, "busy" + patchID);
            if (resp.worked) {
                updateRevTicks(resp.removedRevids, true, remRev);
                updateRevTicks(resp.addedRevids, false, addRev);
            }
            AJS.CRU.CREATE.setAddRemAll(patchID, incRevs, revs);
        };

        AJS.FECRU.AJAX.ajaxDo(url, params, done);
    };

    AJS.CRU.CREATE.setAddRemAll = function (patchID, incRevs, revs) {
        var $addAll = AJS.$("#addAll" + patchID).hide();
        var $remAll = AJS.$("#remAll" + patchID).hide();
        var $hasSome = AJS.$("#containsSome" + patchID).hide();

        var count = countSelected(incRevs);
        if (count == 0) {
            $addAll.show();
        } else if (count < revs.length) {
            $hasSome.show();
        } else {
            $remAll.show();
        }
    };

    var countSelected = function (incRevs) {
        var count = 0;
        for (var i = 0, len = incRevs.length; i < len; i++) {
            if (incRevs[i]) {
                count++;
            }
        }
        return count;
    };

    var updateRespMsgBusy = function (resp, busyId) {
        if (resp.worked) {
            AJS.$("#cart").html(resp.msgHtml);
        }
        if (busyId) {
            AJS.$("#"+busyId).hide();
        }
    };

    var updateRevTicks = function (ids, removed, forEachFunc) {
        AJS.$.each(ids, function() {
            if (removed) {
                AJS.$("#addRev" + this).show();
                AJS.$("#remRev" + this).hide();
            } else {
                AJS.$("#addRev" + this).hide();
                AJS.$("#remRev" + this).show();
            }
            if (forEachFunc) {
                forEachFunc(this);
            }
        });
    };

    AJS.CRU.CREATE.addRemoveFileRevision = function (add, revid, imgPostfix, sourceName) {
        var patchID = sourceName.split(AJS.CRU.CREATE.SOURCE_SEPARATOR)[1];
        var incRevs = AJS.CRU.CREATE.patchesInc[sourceName];
        var revs = AJS.CRU.CREATE.patches[sourceName];
        var busyId = "busyRev" + imgPostfix;
        AJS.$("#addRev" + imgPostfix).hide();
        AJS.$("#remRev" + imgPostfix).hide();
        AJS.$("#"+busyId).show();

        var params = {
            "revid" : revid,
            "command" : add ? "add" : "remove"
        };

        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/editRevisionsAjax/";

        var done = function(resp) {
            var remRev = function(revId) {
                incRevs[revId] = "";
            };
            var addRev = function(revId) {
                incRevs[revId] = revId;
            };
            updateRespMsgBusy(resp, busyId);
            if (resp.worked) {
                updateRevTicks(resp.removedRevids, true, remRev);
                updateRevTicks(resp.addedRevids, false, addRev);
            }
            AJS.CRU.CREATE.setAddRemAll(patchID, incRevs, revs);
        };

        AJS.FECRU.AJAX.ajaxDo(url, params, done);
    };

    AJS.CRU.CREATE.storeStickyPreference = function (key, value) {
        var params = {
            "key" : key,
            "value" : value
        };
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/storeStickyPreferenceAjax/";

        AJS.FECRU.AJAX.ajaxDo(url, params);
    };

    AJS.CRU.CREATE.setSpecificDiffVisible = function (attachMethod) {
        if (attachMethod === 'specificDiff') {
            AJS.$('#specificDiff').show();
        } else {
            AJS.$('#specificDiff').hide();
        }
        AJS.CRU.CREATE.storeStickyPreference('attachMethod', attachMethod);
    };

    var editDetailsRolesChange = false;

    AJS.CRU.CREATE.submitDetailsForm = function () {
        //reload the entire page for now - wont have to refresh when we can update via polling
        var refreshPage = function() {
            window.location = AJS.CRU.UTIL.urlBase(permaId);
        };
        AJS.CRU.REVIEW.UTIL.postEditDetailsForm(refreshPage);
    };

    AJS.CRU.CREATE.markChanged = function (rolesChanged) {
        AJS.CRU.UTIL.editDetailsFormChange = true;
        if (rolesChanged) {
            editDetailsRolesChange = true;
        }
    };

    AJS.CRU.CREATE.checkEditForm = function (done) {
        return AJS.CRU.UTIL.checkEditForm(done);
    };

    AJS.CRU.CREATE.checkEditAndSubmitThis = function (formElement) {
        var submitter = function() {
            formElement.form.submit();
        };
        AJS.FECRU.UI.swapDatesIfReversed(function(dateString) {
            return dateString.substring(0, dateString.indexOf("T"));
        });
        AJS.CRU.CREATE.checkEditForm(submitter);
    };

    AJS.CRU.CREATE.command = function (cmd, pid, button) {
        AJS.CRU.UTIL.command(cmd, pid, button);
    };

    //This validates the saneness of the team selection removing and disabling the
    //selection of author and moderator as reviewers.
    AJS.CRU.CREATE.validateTeamSelection = function () {
        var form = document.editDetailsForm;
        var mod = form.newModerator.value;
        var auth = form.newAuthor.value;
        var reviewers = form.reviewers;
        if (reviewers) {
            for (var i = 0, len = reviewers.length; i < len; i++) {
                var reviewer = reviewers[i];
                if (reviewer.value == mod || reviewer.value == auth) {
                    reviewer.checked = false;
                    reviewer.disabled = true;
                } else {
                    reviewer.disabled = false;
                }
            }
        } else if (reviewers) {
            reviewers.checked = false;
            reviewers.disabled = true;
        }
    };

    AJS.CRU.CREATE.addInvitee = function () {
        var $input = AJS.$("#inviteeInput");
        var invitee = $input.val();
        if (!invitee) {
            return;
        }
        var $invitees = AJS.$("#inviteeSpan");

        var $newInvitee = AJS.$("<input name='invitees' type='checkbox' checked='checked' tabindex='8'>")
                .val(invitee);

        var $textSpan = AJS.$("<span>" + invitee + "; </span>");

        var $newSpan = AJS.$("<span id='inv_"+invitee+"'></span>")
                .append($newInvitee)
                .append($textSpan);

        $invitees.append($newSpan);

        AJS.CRU.UTIL.editDetailsFormChange = true;
        $input.val('');
    };
})();
