if (!AJS.CRU) {
    AJS.CRU = {};
    AJS.CRU.UI = {};
} else if (!AJS.CRU.UI) {
    AJS.CRU.UI = {};
}

(function() {
    AJS.CRU.UI.columnFillHeight = function () {
        var head = AJS.$("#content").offset();
        var foot = AJS.$('#footer').outerHeight();
        var windowHeight = AJS.$(window).height() - foot - 1.3;//window - masthead - roundingerrorhack
        var contentHeight = windowHeight - head.top + 1; // TODO where does this +1 come from

        AJS.$("#content").css({
            paddingBottom: 0,
            height: contentHeight
        });

        AJS.$("#content-resizable").css({
            height: contentHeight
        });

        AJS.$("#content-navigation-panel").css({
            height: windowHeight - AJS.$('#content-navigation-panel').offset().top - 6
        });

        AJS.$("#content-column").css({
            height: contentHeight,
            marginRight: "auto",
            marginLeft: "auto"
        });

        AJS.$("#frx-pane").css({
            height: windowHeight - AJS.$("#frx-pane").offset().top
        });
    };

    AJS.CRU.UI.columnResize = function () {
        AJS.$("#content-resizable").resizable({
            distance: 20,
            handles: "e"
        });
    };

    var isSingleFrxView = false; // gets really initialised in document.ready below

    AJS.CRU.UI.isSingleFrxView = function () {
        return isSingleFrxView;
    };

    AJS.CRU.UI.toggleSingleFrxView = function () {
        isSingleFrxView = !isSingleFrxView;
        AJS.$("#single-frx-view-toggle").toggleClass("selected", isSingleFrxView);
        AJS.$("body").toggleClass("single-frx-view", isSingleFrxView);
    };

    var fullscreen = false;

    AJS.CRU.UI.isFullscreen = function () {
        return fullscreen;
    };

    AJS.CRU.UI.toggleFullscreen = function () {
        fullscreen = !fullscreen;
        AJS.$("#fullscreen-toggle").toggleClass("selected", fullscreen);
        AJS.$("body").toggleClass("fullscreen", fullscreen);
        AJS.$("#single-frx-view-toggle").toggleClass("disabled", fullscreen);

        AJS.$(window).trigger('panes-resized');
        AJS.CRU.UI.columnFillHeight(); // Makes sure the content panes are the correct height
    };

    AJS.$(document).ready(function(){
        // Give a warning if firebug is running
        // NB: do this before columnFillHeight() because this function may insert content into the page
        AJS.FECRU.UI.warnAboutFirebug(function() {
            AJS.CRU.UI.columnFillHeight();
        });

        // When resizing the window, resize the panes
        AJS.$(window).resize(function () {
            AJS.CRU.UI.columnFillHeight();
            AJS.$(window).trigger('panes-resized');
        });
        AJS.$("#content-resizable").bind('resizestop', function () {
            AJS.$(window).trigger('panes-resized');
        });

        isSingleFrxView = AJS.$("body").hasClass("single-frx-view");

        // And make sure the page is setup appropriately on first load
        AJS.CRU.UI.columnResize();
        AJS.CRU.UI.columnFillHeight();
    });
})();
