(function() {

   // On load
    AJS.$(document).ready( function() {

        // Click to focus comments and mark as read.
        AJS.$('#frxs .frxouter .comment').live('click', function (e) {
            if (!AJS.$(this).is('.hover-comment')) {
                commentScrollTracker.setCurrentElement(this, true);
            }
            AJS.CRU.COMMENT.markCommentRead(AJS.$(this).parent().attr('id'));
        });

        AJS.$(".comment a.publishComment").live("click", function() {
            var comment = AJS.CRU.COMMENT.commentFromInnerElement(this);
            commentator.publishComment(comment.id(), permaId);
        });

        AJS.$(".comment a.replyToComment").live("click", function() {
            var comment = AJS.CRU.COMMENT.commentFromInnerElement(this);
            var handleId = comment.visiblePosition() + "replyFormDiv" + comment.id() + "Handle";
            var parentId = comment.visiblePosition() + "replyFormDiv" + comment.id();
            commentator.displayReplyCommentForm(handleId, parentId, comment.id());
        });

        AJS.$(".comment a.editComment").live("click", function() {
            var comment = AJS.CRU.COMMENT.commentFromInnerElement(this);
            var commentId = comment.id();
            var position = comment.visiblePosition();
            var handleId = position + "commentContent" + commentId;
            var parentId = position + "commentEdit" + commentId;

            var isReply = comment.isReply();
            var $p = AJS.$("#" + parentId);
            $p.toggleClass("replyCommentForm", isReply);

            if(isReply) {
                commentator.displayReplyCommentForm(handleId, parentId, comment.replyTo().id(), commentId);
            } else {
                var frx = comment.frx();
                if(frx) {
                    var frxId = frx.id();
                    if (comment.isInline()) {
                        commentator.displayRevisionCommentForm(handleId, parentId, frxId, commentId);
                    } else {
                        commentator.displayFileCommentForm(handleId, parentId, frxId, commentId);
                    }
                } else {
                    commentator.displaySimpleCommentForm(handleId, parentId, commentId);
                }
            }
        });

        AJS.$(".comment a.deleteComment").live("click", function() {
            var comment = AJS.CRU.COMMENT.commentFromInnerElement(this);
            commentator.deleteComment(comment.id(), permaId);
        });

        AJS.$(".comment a.toggleCommentRead").live("click", function() {
            var comment = AJS.CRU.COMMENT.commentFromInnerElement(this);
             commentator.toggleCommentRead(comment.id(), true);
        });

        AJS.$(".comment img.nextCommentThread").live("click", function() {
            var CRU_COMMENT = AJS.CRU.COMMENT;
            var comment = CRU_COMMENT.commentFromInnerElement(this);
            CRU_COMMENT.NAV.nextCommentThread(comment.domId());
            return false;
        });

        AJS.$(".comment img.prevCommentThread").live("click", function() {
            var CRU_COMMENT = AJS.CRU.COMMENT;
            var comment = CRU_COMMENT.commentFromInnerElement(this);
            CRUCOMMENT.NAV.previousCommentThread(comment.domId());
            return false;

        });

        AJS.$(".comment a.commentIssueKeyUnlinked").live("click", function() {
            var comment = AJS.CRU.COMMENT.commentFromInnerElement(this);
            commentAjaxController.linkIssue(comment.id());
        });

        AJS.$(".comment a.commentIssueResolveButton").live("click", function() {
            var comment = AJS.CRU.COMMENT.commentFromInnerElement(this);
            commentAjaxController.resolveIssue(comment.id());
        });

        AJS.$("a.comment-skipped").live("click", function() {
            var commentId = this.id.replace('comment-skipped', '');
            var comment = review.comment(commentId);

            // Presumably, this should never happen - you can't have a skipped comment which isn't inline
            if (!comment || !comment.frx()) {
                return;
            }

            var done = function () {
                var destId = comment.domId();
                AJS.CRU.COMMENT.NAV.scrollToComment({ comment: destId });
            };

             // show full context for the frx
            AJS.CRU.FRX.toggleDiffModeAjax(review.id(), comment.frx().id(), '-1', done);
        });
    });

})();
