AJS.$(document).ready(function() {
    AJS.CRU.FRX.scroller = AJS.CRU.WIDGETS.makeScrollTracker({
        container: AJS.$("#frx-pane")[0],
        selector: function () {
            var ids = AJS.$.map(review.frxs(), function (frx) {
                return '#frxouter' + frx.id();
            });
            ids.push("#generalComments");
            return AJS.$(ids.join()).filter(':visible');
        },
        active: function () {
            AJS.CRU.FRX.frxActivated(this);
        },
        deactive: function () {
            AJS.CRU.FRX.frxDeactivated(this);
            var frxId = this.id !== 'generalComments' ? this.id.replace(/^frxouter/, '') : this.id;
            AJS.$(document).trigger('frx-deactive', [frxId]);
        }
    });

    AJS.CRU.FRX.updateFiltererdFrxCount(); // Setup the count in the filter div

    // Clicking on nav tree directories:
    //   1. If we click on the actual link, then if it is an FRX directory, activate it
    //   2. Otherwise, toggle the subtree
    //   3. If we click on the parent span.folder, then toggle it (dont activate the frx)
    AJS.$("#navigation-tree .tree span.folder").live('click', function(event) {
        var $folder = AJS.$(this);
        var $target = AJS.$(event.target);
        var folderLiId = $target.closest('li.frx-list-item').attr('id');
        if ($target.is('a.frx-dir-item') && folderLiId) {
            AJS.CRU.FRX.scrollFrxPane(folderLiId.replace(/^frx-list-item/, ''));
        } else {
            if ($folder.hasClass("open")) {
                $folder.removeClass("open")
                     .addClass("closed");
            } else {
                $folder.removeClass("closed")
                     .addClass("open");
            }
            $folder.next('.tree').toggle();
        }
    });

    AJS.$("#frx-pane .frxouter .frx-actions").live('click', function (event) {
        var $link = AJS.$(this);
        var frxId = $link.closest(".frxouter").attr("id").replace(/^frxouter/, "");
        AJS.CRU.FRX.toggleFrx(frxId, AJS.$(event.target).is('.add-comment'));
    });

    function scrollToGeneralComments() {
        AJS.CRU.FRX.scrollFrxPane('generalComments');
    }

    AJS.$('#navigation-tree .frx-list-item:not(.filtered) > span > a.scroll-to-frx').live('click', function() {
        var frxId = AJS.$(this).attr('id').replace(/scroll-to-frx/, '');
        AJS.CRU.FRX.scrollFrxPane(frxId);
    });

    AJS.$('#frx-list-item-general-comments:not(.filtered) a').live('click', function() {
        scrollToGeneralComments();
    });

    if (!window.location.hash) {
        scrollToGeneralComments();
    }
});
