AJS.CRU.FRX = (function() {
    var postPostLoadSummarize;
    var postPostLoadFunc = function() {
        review.setLoaded(true);
        AJS.CRU.REVIEW.UTIL.startPollingForReviewUpdates();
        // This is executed after all diffs are finished.
        if (postPostLoadSummarize) {
            res.toggleSource(review.frxIds(), review.inlineCommentIds());
            expandSelected(review.frxIds(),review.frxIdsWithComments(),'frxinner');
        }
        commentator.setCommentWidths(null,true);
        commentator.g_pageCompletelyLoaded = true;
    };

    var optimizedFrxList = function (alreadyLoadedFrx) {
        var a = review.frxIdsWithComments().concat(review.frxIdsWithoutComments());
        if (alreadyLoadedFrx) {
            // Remove frxs which are in alreadyLoadedFrx
            a = AJS.$.grep( a, function(n) {
               return n != alreadyLoadedFrx;
            });
        }
        return a;
    };

    var filterFrxsFromHash = function () {
        if (/^#f-/.test(window.location.hash)) {
            var csv = window.location.hash.replace(/^#f-/, '');
            AJS.CRU.REVIEW.UTIL.filterAndExpandFrxs(csv.split(','));
        }
    };

    var reloadFrxs = function (opts) {
        //reset some global vars to reload the diffs
        review.setFrxsUnloaded();
        commentator.g_pageCompletelyLoaded = false;
        var loadOpts = {
            diffMode : opts.diffOpts,
            isForcedReload : true
        };
        res.revPostLoad(false, loadOpts);
    };

    var activateFirstUnfilteredFrx = function () {
        var frxToActivate;

        if (!AJS.$('#frx-list-item-general-comments').hasClass('filtered')) {
            frxToActivate = AJS.$('#generalComments')[0];
        } else {
            var nonFilteredFrxs = AJS.$.grep(review.frxs(), function (frx) { return !frx.isFiltered(); });
            if (nonFilteredFrxs.length > 0) {
                frxToActivate = AJS.$('#frxouter' + nonFilteredFrxs[0].id())[0];
            }
        }
        AJS.CRU.FRX.scroller.ignoreNextScroll();
        if (frxToActivate) {
            AJS.$('#frx-pane').scrollTo(frxToActivate);
        }
        AJS.CRU.FRX.scroller.setCurrentElement(frxToActivate, true);
    };

    var res = {

        hideFrx : function (frxId) {
            if (frxId === 'generalComments') {
                AJS.$('#generalComments,#frx-list-item-general-comments').addClass('filtered');
            } else {
                AJS.$('#frxouter' + frxId + ',#frx-list-item' + frxId).addClass('filtered');
                review.frx(frxId).setFiltered(true);
            }
        },

        showFrx : function (frxId) {
            if (frxId === 'generalComments') {
                AJS.$('#generalComments,#frx-list-item-general-comments').removeClass('filtered');
            } else {
                AJS.$('#frxouter' + frxId + ',#frx-list-item' + frxId).removeClass('filtered');
                review.frx(frxId).setFiltered(false);
            }
        },

        expandFrx : function (frxId) {
            var frx = review.frx(frxId);
            if (frx && !frx.isExpanded()) {
                res.expandFrxs(frx.id());
            }
        },

        toggleFrx : function (frxId, onlyOpen) {
            var current = AJS.CRU.FRX.scroller.getCurrentElement();
            if (frxId === 'generalComments') {
                var $generalOuter = AJS.$('#' + frxId);
                var $generalInner = $generalOuter.find('#generalCommentsInner');
                if ($generalInner.is(':visible') && $generalOuter[0] === current && !onlyOpen) {
                    $generalInner.removeClass("open").addClass("closed");
                } else {
                    $generalInner.removeClass("closed").addClass("open");
                    AJS.CRU.FRX.scroller.setCurrentElement($generalOuter[0], true);
                }
            } else {
                var frx = review.frx(frxId);
                var frxOuter = AJS.$('#frxouter' + frxId)[0];
                if (frx.isExpanded() && frxOuter === current && !onlyOpen) {
                    res.collapseFrxs([frxId]);
                } else {
                    res.expandFrxs([frxId]);
                    AJS.CRU.FRX.scroller.setCurrentElement(frxOuter, true);
                }
            }
        },

        expandFrxs : function (frxIds) {
            if (AJS.CRU.UI.isSingleFrxView() && !AJS.CRU.UI.isFullscreen()) {
                return;
            }
            frxIds = AJS.$.makeArray(frxIds);
            AJS.$.each(frxIds, function () {
                AJS.$("#frxinner" + this).removeClass("closed").addClass("open");
                review.frx(this).setExpanded(true);
                setFrxDimHeight(this);
            });
            commentScrollTracker.rescan();
            AJS.CRU.FRX.scroller.rescan();
        },

        collapseFrxs : function (frxIds) {
            if (AJS.CRU.UI.isSingleFrxView() && !AJS.CRU.UI.isFullscreen()) {
                return;
            }
            frxIds = AJS.$.makeArray(frxIds);
            AJS.$.each(frxIds, function () {
                AJS.CRU.FRX.collapseFrx(this);
            });
            commentScrollTracker.rescan();
            AJS.CRU.FRX.scroller.rescan();
        },

        collapseFrx : function (id) {
            AJS.$("#frxinner" + id).removeClass("open").addClass("closed");
            review.frx(id).setExpanded(false);
        },

        updateFiltererdFrxCount : function () {
            var unfilteredCount = AJS.$('#navigation-tree .frx-list-item:not(.filtered) > .frx').length;
            var filteredCount = AJS.$('#navigation-tree .frx-list-item.filtered > .frx').length;

            AJS.$('#filter-frxs-shown-count').text(unfilteredCount);
            AJS.$('#filter-frxs-unshown-count').text(filteredCount);

            if (AJS.$('#frxFilterOptions li.selected').length > 0) {
                AJS.$("#navigation-filter-link").parent().addClass("filter-enabled");
            } else {
                AJS.$("#navigation-filter-link").parent().removeClass("filter-enabled");
            }

            if (review.frxs().length > 0 && unfilteredCount === 0) {
                AJS.$('#frx-context-info').hide();
                AJS.$('#frxs-filtered-warning').show();
            } else {
                AJS.$('#frx-context-info').show();
                AJS.$('#frxs-filtered-warning').hide();
            }
            syncFrxButtons();
        },

        filterFrxs : function () {
            var frxFilterOptions = AJS.$.map(
                AJS.$('#frxFilterOptions li.selected'),
                function (e) { return AJS.$(e).attr('id').replace("frx-filter-", ""); }
            );
            var incomplete = AJS.$.inArray('incomplete', frxFilterOptions) >= 0;
            var comments = AJS.$.inArray('comments', frxFilterOptions) >= 0;
            var unreadcomments = AJS.$.inArray('unreadcomments', frxFilterOptions) >= 0;
            var subtasks = AJS.$.inArray('subtasks', frxFilterOptions) >= 0;
            var unresolvedsubtasks = AJS.$.inArray('unresolvedsubtasks', frxFilterOptions) >= 0;
            var draftcomments = AJS.$.inArray('draftcomments', frxFilterOptions) >= 0;
            var defects = AJS.$.inArray('defects', frxFilterOptions) >= 0;
            var binary = AJS.$.inArray('binary', frxFilterOptions) >= 0;
            var nonbinary = AJS.$.inArray('nonbinary', frxFilterOptions) >= 0;
            var nondirectory = AJS.$.inArray('nondirectory', frxFilterOptions) >= 0;
            var newsincecomplete = AJS.$.inArray('newsincecomplete', frxFilterOptions) >= 0;
            var isCommentLevelFilter = unreadcomments || subtasks || unresolvedsubtasks || draftcomments || defects;

            var filterEnabled = frxFilterOptions.length > 0;
            if (filterEnabled) {
                AJS.$("#clear-filter-link").show();
            } else {
                AJS.$("#clear-filter-link").hide();
            }

            var mockGeneralCommentsFrx = {
                id: function () { return 'generalComments'; },
                hasComments: function () { return review.generalComments().length > 0; },
                comments: function () { return review.generalComments(); },
                isComplete: function () { return true; },
                isBinary: function () { return false; },
                isDirectory: function () { return false; },
                isNewSinceComplete: function () { return false; }
            };
            AJS.$.each(AJS.$.merge([mockGeneralCommentsFrx], review.frxs()), function () {
                //if any frx-level filters do not match, hide this frx
                if ((incomplete &&
                        this.isComplete()) ||
                    (comments &&
                        !this.hasComments()) ||
                    (binary &&
                        !this.isBinary()) ||
                    (nonbinary &&
                        this.isBinary()) ||
                    (nondirectory &&
                        this.isDirectory()) ||
                    (newsincecomplete &&
                        !this.isNewSinceComplete())) {
                    res.hideFrx(this.id());
                    return true;
                }
                if (isCommentLevelFilter) {
                    //on a comment-level filter, hide if no comments
                    if (!this.hasComments()) {
                        res.hideFrx(this.id());
                        return true;
                    }
                    var hide = true;
                    AJS.$.each(this.comments(), function () {
                        //show this frx if any comment matches all the comment-level filters
                        if (!(unreadcomments && !(this.status() === 'unread' || this.status() === 'leaveUnread') ||
                                subtasks && !(this.issueKey() && this.issueKey() != '') ||
                                unresolvedsubtasks && !(this.issueKey() && this.issueKey() != '' && this.issueStatus() != 'Resolved') ||
                                draftcomments && !(this.draft()) ||
                                defects && !(this.defect()))) {
                            hide = false;
                        }
                    });
                    if (hide) {
                        res.hideFrx(this.id());
                        return true;
                    }
                }

                res.showFrx(this.id());
                res.expandFrx(this.id());
            });
            commentScrollTracker.rescan();
            AJS.CRU.FRX.scroller.rescan();
            var $currentFrx = AJS.$(AJS.CRU.FRX.scroller.getCurrentElement());
            if (!$currentFrx.hasClass('frxouter') || $currentFrx.hasClass('filtered')) {
                activateFirstUnfilteredFrx();
            }
            AJS.$('#navigation-tree .folder').parent().addClass('filtered');
            AJS.$('#navigation-tree .frx-list-item:has(li.frx-list-item:not(.filtered))').removeClass('filtered');
            AJS.CRU.FRX.updateFiltererdFrxCount();
        },

        postPostLoadFunc : postPostLoadFunc,

        defaultPostLoad : function (summarize) {
            postPostLoadSummarize = summarize;
            AJS.$(window).bind('panes-resized', function () {
                commentator.setCommentWidths(null, true);
            });
        },

        revPostLoad : function (summarize, loadOpts) {
            res.defaultPostLoad(summarize);
            var anchoredFrx = AJS.CRU.FRX.NAV.checkFrxAnchor();
            if (!anchoredFrx) {
                anchoredFrx = AJS.CRU.COMMENT.NAV.checkCommentAnchor(loadOpts);
            }
            if (!anchoredFrx) {
                filterFrxsFromHash();
            }
            AJS.CRU.FRX.AJAX.frxLazyLoad(optimizedFrxList(anchoredFrx), loadOpts);
            commentAjaxController.loadCommentIssueStatuses();
        },

        toggleAllFrxsSoftWrapping : function (enabled) {
            reloadFrxs({ diffOpts : "&softWrap=" + (enabled ? 's' : 'h')});
        },

        toggleAllFrxsDiffMode : function (mode) {
            reloadFrxs({ diffOpts : "&fv=" + mode});
        },

        toggleSource : function (ids, commentIds) {
            toggleType(ids,'sourcefrxinner');
            if (commentator.showSource) {
                if (commentator.showCommentsInline() && !commentator.showCommentsAbove()) {
                    commentator.toggleComments(ids, commentIds, 'top');
                    AJS.$('#select_source_top').attr('selected','selected');
                }
                commentator.showSource = false;
                AJS.$('#show_source_button').removeClass('selected');
                // hide all the diff context bars if source is not shown
                for (var i = 0; i < ids.length; i++) {
                    var diffContextBar = AJS.$('#diffControls' + ids[i]);
                    if (diffContextBar.length === 1) {
                        diffContextBar.removeClass('diffContextShow');
                        diffContextBar.addClass('diffContextHidden');
                    }
                }
            } else {
                AJS.$('#show_source_button').addClass('selected');
                commentator.showSource = true;
            }
        },

        toggleCommitMessages : function (btn) {
            AJS.$(btn).toggleClass('pressed');
            toggleType(review.frxIds(),'changeset_detailsfrxinner');
        },

        changeBlankLines: function (permaId, frxId, bl) {
             res.changeWhitespace(permaId, frxId, null, bl);
        },

        changeWhitespace : function (permaId, frxId, ws, bl) {
            var params = res.diffParams(frxId, {whiteSpace: ws, blankLines: bl}) + "&showDiffContextBar=true";
            params += AJS.CRU.FRX.AJAX.frxRevisionParams(frxId);
            AJS.CRU.FRX.AJAX.toggleSourceType(permaId, frxId, false, params);
        },

        whiteSpaceParams: function (frxId, ws) {
            if (!ws) {
                ws = AJS.$('#view_opts' + frxId + ' li.frx-whitespace-opt.selected:not(#blank_lines_toggle' + frxId + ') .value').val();
            }
            return 'ws=' + ws;
        },

        blankLinesParams: function (frxId, bl) {
            if (bl === null || bl === undefined) {
                bl = AJS.$('#blank_lines_toggle' + frxId).hasClass('selected');
            }
            return 'bl=' + bl;
        },

        contextParams: function (frxId, context) {
            if (!context) {
                context = AJS.$('#view_opts' + frxId).val();
            }
            return 'u=' + context;
        },

        keywordsParams: function (frxId, keywords) {
            if (!keywords) {
                keywords = AJS.$('#diffKeywords' + frxId).val();
            }
            return 'k=' +keywords;
        },

        diffOptsParams: function (frxId, opt) {
            if (!opt) {
                opt = AJS.$('#view_opts' + frxId + ' li.frx-diff-layout-opt.selected .value').val();
            }
            return 'fv=' + opt;
        },

        diffParams: function (frxId, map) {
            map = map || {};
            return '&' + res.contextParams(frxId, map.context) +
                   '&' + res.diffOptsParams(frxId, map.diffOpts) +
                   '&' + res.blankLinesParams(frxId, map.blankLines) +
                   '&' + res.whiteSpaceParams(frxId, map.whiteSpace);
        },

        reloadSingleFrx : function (permaId, frxId, diffOpts) {
            var params = res.diffParams(frxId, {'diffOpts' : diffOpts}) + "&showDiffContextBar=true";
            params += AJS.CRU.FRX.AJAX.frxRevisionParams(frxId);
            AJS.CRU.FRX.AJAX.toggleSourceType(permaId, frxId, false, params, null);
        },

        toggleDiffModeAjax : function (permaId, frxId, u, done) {
            var params = res.diffParams(frxId, {'context': u});
            params += AJS.CRU.FRX.AJAX.frxRevisionParams(frxId);
            AJS.CRU.FRX.AJAX.toggleSourceType(permaId, frxId, false, params, done);
        },

        toggleDiffContext : function (diffContextId, toggleLinkId) {
            var diffContext = AJS.$("#"+diffContextId);
            var isHidden = diffContext.hasClass('diffContextHidden');
            var diffContextStyleToAdd = 'diffContext' + (isHidden ? 'Show' : 'Hidden');
            var diffContextStyleToRemove = 'diffContext' + (isHidden ? 'Hidden' : 'Show');
            diffContext.removeClass(diffContextStyleToRemove).addClass(diffContextStyleToAdd);
            var toggleLink = AJS.$("#"+toggleLinkId);
            // take out or add in, the background color/tab for the toggle link.
            if (!isHidden) {
                toggleLink.removeClass('diffControlToggle');
            } else {
                toggleLink.addClass('diffControlToggle');
            }
        },

        frxActivated : function (frxOuter) {
            var frxId = frxOuter.id.replace('frxouter', '');
            AJS.$(frxOuter).addClass("activeFrx");
            var controls;
            if (frxId === 'generalComments') {
                // general controls
                controls = AJS.$('#generalControls').find('.frxControls');
                AJS.$("#frx-list-item-general-comments").addClass("activeFrx");
            } else {
                controls = AJS.$('#frxControlsContainer' + frxId).find('.frxControls');
                AJS.$("#frx-list-item" + frxId).addClass("activeFrx");
            }
            // Appending moves the elements (and their events) in this case.
            AJS.$('#frx-context-info').append(controls);

            if (commentScrollTracker) {
                commentScrollTracker.rescan();
            }
            
            syncFrxButtons();
        },

        frxDeactivated : function (frxOuter) {
            var frxId = frxOuter.id.replace('frxouter', '');
            AJS.$(frxOuter).removeClass("activeFrx");
            var container;
            if (frxId === 'generalComments') {
                // general controls
                container = AJS.$('#generalControls');
                AJS.$("#frx-list-item-general-comments").removeClass("activeFrx");
            } else {
                container = AJS.$('#frxControlsContainer' + frxId);
                AJS.$("#frx-list-item" + frxId).removeClass("activeFrx");
            }
            // Appending moves the elements (and their events) in this case.
            AJS.$(container).append(AJS.$('#frx-context-info').find('.frxControls'));
        },

        dimFrx : function (frxId) {
            // sanity check
            if (!review.frx(frxId)) {
                return;
            }
            var $inner = AJS.$("#sourcefrxinner" + frxId);

            var $blanket = AJS.$("<div id='frx-dim-"+frxId+"' class='frx-dim'>&nbsp;</div>" +
                                 "<div class='frx-dim-msg'>Updating source...</div>");

            $blanket.css({
                height: $inner.height(),
                width: AJS.$("#sourceTable" + frxId).width() // Source table can push out from parent dimensions
            });
            $inner.prepend($blanket);
        },

        scrollFrxPane : function (containerId) {
            var frxTracker = AJS.CRU.FRX.scroller;

            var itemOuter;
            if (containerId === 'generalComments') {
                itemOuter = AJS.$('#generalComments')[0];
            } else {
                AJS.CRU.FRX.expandFrx(containerId);
                itemOuter = AJS.$('#frxouter' + containerId)[0];
            }
            if (itemOuter) {
                frxTracker.ignoreNextScroll();
                AJS.$('#frx-pane').scrollTo(itemOuter);
                frxTracker.setCurrentElement(itemOuter, true);
            }
        }
    };

    var syncFrxButtons = function () {
        // Sync the file nav buttons
        var frxs = AJS.$.grep(review.frxIds(), function (frxId) {
            return !review.frx(frxId).isFiltered();
        });

        if (!AJS.$('#generalComments').hasClass('filtered')) {
            frxs = AJS.$.merge(["generalComments"], frxs);
        }

        var frxCount = frxs.length;
        if (frxCount === 0) {
            AJS.$("#frxs div.toolbar li.prev-file-button").addClass("disabled");
            AJS.$("#frxs div.toolbar li.next-file-button").addClass("disabled");
        } else {
            var frxIndex = AJS.$(frxs).index(AJS.CRU.FRX.NAV.getCurrentFrxId());
            var firstFrx = frxIndex === 0;
            var lastFrx = frxIndex === frxCount - 1;
            AJS.$("#frxs div.toolbar li.prev-file-button").toggleClass("disabled", firstFrx);
            AJS.$("#frxs div.toolbar li.next-file-button").toggleClass("disabled", lastFrx);
        }
    };

    var setFrxDimHeight = function (frxId) {
        AJS.$("#frx-dim"+frxId).css("height", AJS.$("#sourcefrxinner" + frxId).height());
    };

    return res;
})();

