if (!AJS.CRU.REVIEW.EVENTS) {
    AJS.CRU.REVIEW.EVENTS = {};
}

(function() {
    AJS.$(document).ready(function() {

        AJS.$("#dueDateString")
            .attr("autocomplete", "off")
            .datepicker({
                dateFormat: 'yy-mm-dd',
                minDate: new Date(),
                onClose: function(dateText) {
                    if (dateText.length === 10) {
                        AJS.$(this).attr("value", dateText + "T00:00:00");
                    }
                }
            });

        AJS.$('.frxouter:not(.activeFrx)').live('mousedown', function (e) {
            var $target = AJS.$(e.target || e.srcElement);
            if ($target.is('#generalComments, .frx-actions')
                    || $target.parents('.frx-actions').length === 1) {
                return true;
            }
            AJS.CRU.FRX.scroller.setCurrentElement(this, true);
            var $parentRow = $target.parents('tr:last');
            if ($parentRow.length > 0) {
                return commentator.selectLine_down(e, $parentRow.get(0), true);
            }
            return true;
        });

        // Event delegation for frx commentable lines.
        // Huge performance boost for reviews with thousands of lines of frx lines
        AJS.$('.activeFrx table.inlineSource tr.commentableLine td:not(.tetrisColumnFrom, .tetrisColumnTo, .tetrisColumn)')
            .live( "mouseover", function(e) {
                return commentator.selectLine_over(e, AJS.$(this).parents('tr:last').get(0));
            });

        AJS.$('.activeFrx table.inlineSource tr.commentableLine td:not(.tetrisColumnFrom, .tetrisColumnTo, .tetrisColumn)')
            .live( "mousedown", function(e) {
                return commentator.selectLine_down(e, AJS.$(this).parents('tr:last').get(0));
            });

        AJS.$('.activeFrx table.inlineSource tr:not(#commentTR, .comment-row) td:not(.tetrisColumnFrom, .tetrisColumnTo, .tetrisColumn)')
            .live( "mouseup", function(e) {
                return commentator.selectLine_up(e, AJS.$(this).parents('tr:last').get(0));
        });

        AJS.$("#linkReviewFormForm").keypress(function(e) {
            var key = e.which || e.keyCode;
            var el = e.target || e.srcElement;
            if ((key === AJS.$.ui.keyCode.ENTER || key === AJS.$.ui.keyCode.TAB) && el.type != 'textarea') {
                if (AJS.CRU.REVIEW.UTIL.postLinkedReview) {
                    AJS.CRU.REVIEW.UTIL.postLinkedReview();
                }
                return false;
                //TODO: Port to jQuery events and e.stopPropagation();
            }
            return false;
        });

        AJS.$("#linkReviewSaveButton").live("click", function() {
            AJS.CRU.REVIEW.UTIL.postLinkedReview();
            return false;
        });

        AJS.$("#linkReviewUnlinkButton").live("click", function() {
            AJS.CRU.REVIEW.UTIL.postUnlinkReview();
            return false;
        });

        AJS.$("#addInviteeButton").click(function () {
            AJS.CRU.CREATE.addInvitee();
        });

        AJS.$("#suggestionButton").click(function(event) {
            AJS.CRU.REVIEW.UTIL.suggestReviewers(event, this);
            return false;
        });

        // Jira links get loaded by Ajax
        AJS.$("#jiraIssueQuickLink").live("click", function() {
            var suggestedIssueKey = AJS.$(this).siblings("input[name=suggestedIssueKey]").val();
            AJS.CRU.REVIEW.UTIL.findAndLinkJiraIssue(suggestedIssueKey);
            return false;
        });

        AJS.$("#jiraFindButton").live("click", function() {
            AJS.CRU.REVIEW.UTIL.findJiraIssue();
            return false;
        });

        AJS.$("#jiraClearButton").live("click", function() {
            AJS.CRU.REVIEW.UTIL.unlinkJiraIssue();
            return false;
        });

        var toggleAndResize = function ($elem) {
            $elem.toggle();
            AJS.CRU.UI.columnFillHeight();
        };

        AJS.$("#participantList,#patchList").click(function() {
            toggleAndResize(AJS.$(this).siblings(".expandable"));
        });

        AJS.$('#clear-filter-link').click(function () {
            AJS.$('#frxFilterOptions li.selected').removeClass("selected");
            AJS.CRU.FRX.filterFrxs();
        });

        AJS.$('#expandAllFrxs').click(function () {
            AJS.CRU.FRX.expandFrxs(review.frxIds());
            return false;
        });

        AJS.$('#collapseAllFrxs').click(function () {
            AJS.CRU.FRX.collapseFrxs(review.frxIds());
        });

        AJS.$('#frxFilterOptions li.frx-filter-option').click(function (e) {
            AJS.$(this).toggleClass("selected");
            AJS.CRU.FRX.filterFrxs();
            e.stopPropagation(); // Don't let the menu be closed when selecting options
        });

        AJS.$("#set-inline-comments a").click(function () {
            commentator.toggleComments(review.frxIds(), review.inlineCommentIds(), 'inline');
            commentScrollTracker.rescan();
        });

        AJS.$("#set-above-comments a").click(function () {
            commentator.toggleComments(review.frxIds(), review.inlineCommentIds(), 'top');
            commentScrollTracker.rescan();
        });

        AJS.$("#set-hidden-comments a").click(function () {
            commentator.toggleComments(review.frxIds(), review.inlineCommentIds(), 'none');
            commentScrollTracker.rescan();
        });

        AJS.$("#set-side-by-side-diffs a").click(function () {
            AJS.$("#set-unified-diffs").removeClass("selected");
            AJS.$("#set-side-by-side-diffs").addClass("selected");
            AJS.CRU.FRX.toggleAllFrxsDiffMode('s');
        });

        AJS.$("#set-unified-diffs a").click(function () {
            AJS.$("#set-side-by-side-diffs").removeClass("selected");
            AJS.$("#set-unified-diffs").addClass("selected");
            AJS.CRU.FRX.toggleAllFrxsDiffMode('u');
        });

        AJS.$("#set-soft-wrapping-on a").click(function () {
            AJS.$("#set-soft-wrapping-off").removeClass("selected");
            AJS.$("#set-soft-wrapping-on").addClass("selected");
            AJS.CRU.FRX.toggleAllFrxsSoftWrapping(true);
        });

        AJS.$("#set-soft-wrapping-off a").click(function () {
            AJS.$("#set-soft-wrapping-on").removeClass("selected");
            AJS.$("#set-soft-wrapping-off").addClass("selected");
            AJS.CRU.FRX.toggleAllFrxsSoftWrapping(false);
        });

        AJS.$("#single-frx-view-toggle:not(.disabled) a").click(function () {
             AJS.CRU.UI.toggleSingleFrxView();
        });

        AJS.$("#fullscreen-toggle:not(.disabled) a").click(function () {
             AJS.CRU.UI.toggleFullscreen();
        });

        //TODO @seb - needs to be a single element with an id
        AJS.$("li.prev-file-button:not(.disabled)").live("click", function () {
            var frxId = AJS.CRU.FRX.NAV.getCurrentFrxId();
            AJS.CRU.FRX.NAV.gotoFrx({
                frxId: frxId,
                destination: frxId ? 'previous' : 'last'
            });
        });

        //TODO @seb - needs to be a single element with an id
        AJS.$("li.next-file-button:not(.disabled)").live("click", function () {
            var frxId = AJS.CRU.FRX.NAV.getCurrentFrxId();
            AJS.CRU.FRX.NAV.gotoFrx({
                frxId: frxId,
                destination: frxId ? 'next' : 'first'
            });
        });

        //TODO @seb - needs to be a single element with an id
        AJS.$("li.prev-comment-button:not(.disabled)").live("click", function () {
            AJS.CRU.COMMENT.NAV.prevComment();
        });

        //TODO @seb - needs to be a single element with an id
        AJS.$("li.next-comment-button:not(.disabled)").live("click", function () {
            AJS.CRU.COMMENT.NAV.nextComment();
        });

        AJS.$("#mark-comments-read-button:not(.disabled)").live("click", function () {
            AJS.CRU.COMMENT.markAllCommentsRead();
        });

        AJS.$("#addReviewCommentLink:not(.disabled)").live("click", function () {
            commentator.displaySimpleCommentForm(null, 'generalCommentForm');
        });

        //TODO @seb - needs to be a single element with an id
        AJS.$(".addFileCommentLink:not(.disabled)").live("click", function () {
            var frxId = this.id.replace('addFileCommentLink', '');
            commentator.displayFileCommentForm(null, 'fileCommentForm' + frxId, frxId);
        });

        AJS.$("#review-updated-warning .close").live("click", function () {
            AJS.$('#review-updated-warning').slideUp('fast');
        });

        var manageFiles = function (editPage) {
            var dialog = AJS.FECRU.DIALOG.create(1200, 700, "cru-manage-files-dialog");

            var iframeStyle = "style='width:100%;height:" + (dialog.height - 43 - 44) + "px'";
            editPage = editPage || (review.isEmpty() ? "/edit-changelog" : "/edit-content");
            var cs = "<iframe frameborder='0' name='editReviewIframe' src='" + AJS.CRU.UTIL.urlBase(permaId) + editPage + "' " + iframeStyle + "></iframe>";

            dialog.addHeader("Edit Review")
                  .addPanel("Manage", cs);
            
            if (review.isEmpty()) {
                dialog.addButton("Abandon Review", function(dialog) {
                    AJS.CRU.UTIL.stateTransition('action:abandonReview', permaId);
                    dialog.hide();
                });
            }
            dialog.addButton("Done", function(dialog) {
                AJS.CRU.CREATE.submitDetailsForm();
            }).show();
        };

        // Live event: button is replaced by ajax content load after saving an edited review
        AJS.$("#edit-review-link:not(.disabled)").live("click", function() {
            editReview();
            return false;
        });

        var editReview = function () {
            manageFiles('/edit-details');
        };

        var summarizeDialog = 0;
        AJS.CRU.REVIEW.createSummarizeDialog = function () {
            summarizeDialog = AJS.CRU.DIALOG.ajaxDialog(640, 480);
            summarizeDialog.addHeader("Summarize Review")
                  .addPanel("Summarize", AJS.$("#closingComment"))
                  .addButton("Continue Without Closing", function(summarizeDialog) {
                summarizeDialog.hide();
            })
                  .addButton("Close Review", function(summarizeDialog) {
                AJS.CRU.REVIEW.UTIL.closeReviewAjax();
                summarizeDialog.hide();
            });
        };

        AJS.CRU.REVIEW.openSummarizeDialog = function () {
            if (summarizeDialog === 0) {
                AJS.CRU.REVIEW.createSummarizeDialog();
            }
            summarizeDialog.show();
        };

        if (!review.isValid() && review.writable() && (review.isDraft() || review.isOpen()) && !review.isTransitioning() && !AJS.$('body').is('.manage-files')) {
            if (review.isEmpty()) {
                manageFiles();
            } else {
                editReview();
            }
        }

        if (review.isSummarize() && review.writable()) {
            AJS.CRU.REVIEW.openSummarizeDialog();
        }
    });
})();
