if (!AJS.CRU.REVIEW) {
    AJS.CRU.REVIEW = {};
}
if (!AJS.CRU.REVIEW.UTIL) {
    AJS.CRU.REVIEW.UTIL = {};
}

(function() {

    var hideSuggestionBox = function () {
        AJS.$("#suggestionBox").hide();
        AJS.$("#suggestionButton")
            .val("Suggest Reviewers")
            .unbind("click")
            .bind("click", function() {
                AJS.CRU.REVIEW.UTIL.suggestReviewers();
            });
    };

    AJS.CRU.REVIEW.UTIL.findJiraIssue = function () {
        var jiraIssueKey = AJS.$.trim(AJS.$("#jiraIssueKeyField").val());
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/findJiraIssueAjax/";
        var params = {'jiraIssueKey' : jiraIssueKey, "autoLink" : false};
        var $button = AJS.$("#jiraFindButton");

        AJS.FECRU.AJAX.startSpin("jiraFindButton", false, "span", "");

        var done = function(resp) {
            if (resp.worked) {
                AJS.$("#jiraEditDiv").html(resp.jiraEditHtml);
                AJS.$("#jiraDisplayDiv").replaceWith(resp.jiraDisplayHtml);
            } else {
                AJS.$("#jiraEditDiv").append(AJS.$('<span>'+resp.errorMsg+'</span>'));
                $button.attr("disabled","");
            }
            AJS.FECRU.AJAX.stopSpin(AJS.$('#jiraFindButton').get(0), "span");
        };

        $button.attr("disabled","disabled");

        AJS.FECRU.AJAX.ajaxDo(url, params, done);
    };

    AJS.CRU.REVIEW.UTIL.unlinkJiraIssue = function () {
        AJS.$("#queryResult").text("");
        AJS.$("#jiraIssueKeyHidden").val("");
        AJS.$("#jiraIssueQuickLink").show();
    };

    /**
     * This function is used from the review meta info panel to quickly link the review
     * to a jira issue that was suggested by Crucible.
     *
     * @param jiraIssueKey
     */
    AJS.CRU.REVIEW.UTIL.findAndLinkJiraIssue = function (jiraIssueKey) {
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/findJiraIssueAjax/";
        var params = {'jiraIssueKey' : jiraIssueKey, "autoLink" : true};

        AJS.FECRU.AJAX.startSpin("jiraDisplaySpinner", false, "span", "");

        AJS.FECRU.AJAX.ajaxDo(url, params, function(resp) {
            AJS.FECRU.AJAX.stopSpin( AJS.$("#jiraDisplaySpinner")[0] );
            if (resp.worked) {
                AJS.$("#jiraEditDiv").html(resp.jiraEditHtml);
                AJS.$("#jiraDisplayDiv").html(resp.jiraDisplayHtml);
                AJS.$("#jiraIssueQuickLink").hide();
            } else {
                AJS.$("#jiraEditDiv").append(AJS.$('<span>'+resp.errorMsg+'</span>'));
            }
        });
    };

    AJS.CRU.REVIEW.UTIL.suggestReviewers = function () {
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + "/suggestReviewersAjax/";
        var $button = AJS.$("#suggestionButton");

        var done = function(resp) {
            AJS.FECRU.AJAX.stopSpin($button[0]);
            $button.removeAttr("disabled");
            if (resp.worked) {
                AJS.$("#suggestedReviewers").html( resp.msgHtml );
                AJS.$("#suggestionBox").show();
                $button
                    .val("Close Suggestions")
                    .unbind("click")
                    .bind("click", function() {
                        hideSuggestionBox();
                    });

                AJS.$("#suggestionCount").val( resp.suggestionCount );
            }
            return true;
        };

        AJS.FECRU.AJAX.startSpin("suggestionButton", false, "span", "");
        $button.attr("disabled","disabled");

        AJS.FECRU.AJAX.ajaxDo(url, null, done);
    };

    AJS.CRU.REVIEW.UTIL.addSuggestedReviewer = function (username) {
        AJS.$("#rc_" + username)
            .children(":first")
            .attr("checked","checked")
            .end()
            .show();

        AJS.$("#sug_" + username)
            .hide();

        //hide suggestion box if there are no more suggestions
        var $suggestionCount = AJS.$("#suggestionCount");
        var suggestionCount = parseInt( $suggestionCount.val(), 10 );
        $suggestionCount.val( suggestionCount - 1 );
        if (parseInt($suggestionCount.val(), 10) === 0) {
            hideSuggestionBox();
        }
    };

    AJS.CRU.REVIEW.UTIL.postEditDetailsForm = function (onCompleteFunc) {
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) +'/postDetails';
        var form = document.editDetailsForm;
        try {
            var $iframe = AJS.$('iframe[name="editReviewIframe"]');
            if (!form && $iframe.length == 1) {
                form = $iframe[0].contentDocument.editDetailsForm;
            }
        } catch (e) {
            if (onCompleteFunc) {
                onCompleteFunc();
            }
            return false;
        }
        if (!form) {
            if (onCompleteFunc) {
                onCompleteFunc();
            }
            return false;
        }
        var $form = AJS.$(form);
        var $title = AJS.$(form.title);
        if (!$title.val()) {
            $form.find('.title.required').show();
            $title.focus();
            return false;
        }
        var params = $form.serialize() + '&command=norender';
        AJS.FECRU.AJAX.ajaxDo(url, params, onCompleteFunc);
        return false;
    };

    AJS.CRU.REVIEW.UTIL.closeReviewAjax = function () {
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) + '/setSummary';
        var params = {
            'command': 'action:closeReview',
            'summary': AJS.$("#reviewSummaryInput").val()
        };

        AJS.FECRU.AJAX.ajaxDo(url, params, function (resp) {
            if (resp.worked) {
                if (resp.redirect) {
                    window.location = resp.payload;
                }
            }
        });
        return false;
    };

    AJS.CRU.REVIEW.UTIL.postLinkedReview = function () {
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) +'/linkReview';
        var newParentId = AJS.$("#parentReviewId").val();
        var params = '&parentReviewId=' + newParentId;

        var done = function (resp) {
            if (resp.worked) {
                AJS.$("#unlinkReview").html(resp.unlinkHtml);
            }
        };

        AJS.FECRU.AJAX.ajaxDo(url, params, done);
    };

    AJS.CRU.REVIEW.UTIL.postUnlinkReview = function () {
        var url = AJS.CRU.UTIL.jsonUrlBase(permaId) +'/linkReview';
        var params = {unlinkParent : true };

        var done = function (resp) {
            if (resp.worked) {
                AJS.$("#unlinkReview").html("");
            }
        };

        AJS.FECRU.AJAX.ajaxDo(url, params, done);
    };

    AJS.CRU.REVIEW.UTIL.filterAndExpandFrxs = function (filters) {
        var $filterOptions = AJS.$('#frxFilterOptions');
        AJS.$.each(filters, function (i, filter) {
            $filterOptions.find('li[id=frx-filter-' + filter + ']').addClass('selected');
        });
        AJS.CRU.FRX.filterFrxs();
        AJS.CRU.FRX.expandFrxs(review.frxIds());
    };

    AJS.CRU.REVIEW.UTIL.warnAboutReviewUpdates = function (reshowWarning) {
        var notShownYet = !AJS.$('body').hasClass('review-updated');
        AJS.CRU.REVIEW.UTIL.reviewUpdatedAjax(function () {
            if (AJS.$('body').hasClass('review-updated')) {
                if (notShownYet || reshowWarning) {
                    AJS.$('#review-updated-warning').slideDown('fast');
                }
            }
        });
    };

    /**
     * If on the review page, checks if the review has been updated since last refresh.
     *
     * If the review has been updated, the body has the class `review-updated` added.
     * Silently fails if the Ajax request fails.
     *
     * @param onDone no arg callback called regardless of whether the request is made.
     */
    AJS.CRU.REVIEW.UTIL.reviewUpdatedAjax = function (onDone) {
        var util = AJS.CRU.UTIL;
        onDone = onDone || function () {};
        if (!util.isReviewPage() || AJS.$('body').hasClass('review-updated')) {
            onDone();
            return;
        }

        var url = util.jsonUrlBase(review.id()) + '/reviewUpdatedAjax';

        // TODO Invert the logic so that server sends the last modified timestamps, FRXs, and revisions.
        // Serialize render times and visible frxs.
        var params = {
            reviewRenderTime: review.getRenderTime().getTime()
        };
        var frxIds = [];
        var frxRenderTimes = [];
        var frxSliderRevsLengths = [];
        var frxSliderRevsArrays = [];
        AJS.$.each(review.frxs(), function (i, frx) {
            frxIds.push(frx.id());
            frxRenderTimes.push(frx.getRenderTime().getTime());
            var sliderRevs = frx.getSliderFrxRevisions();
            frxSliderRevsLengths.push(sliderRevs.length);
            frxSliderRevsArrays.push(sliderRevs);
        });
        params.frxIds = frxIds;
        params.frxRenderTimes = frxRenderTimes;
        params.frxSliderRevsLengths = frxSliderRevsLengths;
        params.frxSliderRevs = Array.prototype.concat.apply([], frxSliderRevsArrays);

        AJS.FECRU.AJAX.ajaxDo(url, params, function (resp) {
            if (resp.worked && resp.value === 1) {
                AJS.$('body').addClass('review-updated');
            } else {
                // Silently fail when resp.worked === false.
            }
            onDone();
        }, true);
    };


    var lastActivityMs = new Date().getTime();
    var pollingDelay;

    /**
     * For the first INACTIVITY_BEFORE_BACKOFF ms (e.g., 5 min) since the last activity, poll
     * every DELAY_MIN ms (e.g., 20 sec). After the INACTIVITY_BEFORE_BACKOFF, start backing
     * off the polling period to a maximum of DELAY_MAX ms (e.g., 1 hr).
     *
     * The backoff is required, e.g., if you leave your browser open overnight.
     */
    function calcTimeout() {
        var DELAY_MIN = 1000 * 20;
        var DELAY_MAX = 1000 * 60 * 60;
        var DELAY_MULTIPLIER = 1.25;
        var INACTIVITY_BEFORE_BACKOFF = 1000 * 60 * 5;

        var t = new Date().getTime() - lastActivityMs;
        if (t < INACTIVITY_BEFORE_BACKOFF) {
            pollingDelay = DELAY_MIN;
        } else {
            pollingDelay *= DELAY_MULTIPLIER;
        }
        pollingDelay = pollingDelay > DELAY_MAX ? DELAY_MAX : pollingDelay;
        return pollingDelay;
    }

    var pollingTimer;
    
    function doPollingLoop() {
        var rutil = AJS.CRU.REVIEW.UTIL;
        rutil.warnAboutReviewUpdates();
        if (AJS.$('body').hasClass('review-updated')) {
            // Stop polling after first update notice (will change when CRUC-1613 is implemented).
            rutil.stopPollingForReviewUpdates();
        } else {
            pollingTimer = setTimeout(doPollingLoop, calcTimeout());
        }
    }

    AJS.CRU.REVIEW.UTIL.resetInactivityTimer = function () {
        lastActivityMs = new Date().getTime();
    };

    AJS.CRU.REVIEW.UTIL.startPollingForReviewUpdates = function () {
        AJS.CRU.REVIEW.UTIL.stopPollingForReviewUpdates();
        doPollingLoop();
    };

    AJS.CRU.REVIEW.UTIL.stopPollingForReviewUpdates = function () {
        if (pollingTimer) {
            clearTimeout(pollingTimer);
            pollingTimer = undefined;
        }
    };

    AJS.$(document).ready(function () {

        // Poll immediately on focus and start the polling loop.
        AJS.$(window).focus(function () {
            if (review.isLoaded()) {
                // Restart polling for updates.
                var rutil = AJS.CRU.REVIEW.UTIL;
                rutil.resetInactivityTimer();
                rutil.startPollingForReviewUpdates();
            } else {
                // Once all FRXs are loaded, frx.js calls startPollingForReviewUpdates.
            }
        });

        // Resetting on keypress (of shortcuts) is handled by keynav.js since it prevents propagation.
        AJS.$('body').click(function () {
            AJS.CRU.REVIEW.UTIL.resetInactivityTimer();
        });

        // Don't poll at all when the window doesn't have focus.
        AJS.$(window).blur(function () {
            AJS.CRU.REVIEW.UTIL.stopPollingForReviewUpdates();
        });

    });

})();
