(function() {

var $allCheckboxes = [];

AJS.FE.setupDiffCheckboxes = function() {
    // It can be slow to keep on finding all of the checkboxes, so let's cache them
    $allCheckboxes = AJS.$("#history-table input.history-item");

    AJS.$("#history-table input.history-item").live("click",
            function(event) {
                var $checkboxClicked = AJS.$(this);
                var count = $allCheckboxes.filter(':checked').length;
                $allCheckboxes.each(function() {
                    var $node = AJS.$(this);
                    if (count < 2) {
                        $node.attr("disabled", "");
                    } else if (!$node.attr("checked")) {
                        $node.attr("disabled", "disabled");
                    }
                });
                var $r1 = AJS.$("#r1");
                var $r2 = AJS.$("#r2");
                if (count == 0) {
                    $r1.val("");
                    $r2.val("");
                }
                else if (count == 1) {
                    $r2.val("");
                    $allCheckboxes.each(function() {
                        var $node = AJS.$(this);
                        if ($node.attr("checked")) {
                            $r1.val($node.val());
                            return false; // fast exit
                        }
                    });
                }
                else if (count == 2) {
                    if ($checkboxClicked.attr("checked")) {
                        $r2.val($checkboxClicked.val());
                    }
                }
                event.stopPropagation();
            }
            );
};

AJS.FE.showRevisionDetails = function(row) {
    var $row = AJS.$(row);
    var revisionId = revisionIdForRow($row);
    showRevisionDiv(revisionId);
    setRowFocus(revisionId);
};

    var revisionIdForRow = function($row) {
        return $row.find("input.rev-id").val();
    };

    var revisionForRow = function($row) {
        return $row.find("input.history-item").val();
    };

    var revisionForRevisionId = function(revisionId) {
        return revisionForRow(rowForRevisionId(revisionId));
    };

    var revisionIdForRevision = function(revision) {
        return AJS.$("input.history-item[value='" + revision + "']").attr("id").substr("revision-".length);
    };

    var rowForRevisionId = function(revisionId) {
        return AJS.$("#rev-id-" + revisionId).closest("tr");
    };

    var divForRevisionId = function(revisionId) {
        return AJS.$("#revision-div-" + revisionId).closest("div.holder");
    };

    var $shownHolder = undefined;
    var showRevisionDiv = function(revisionId) {
        if ($shownHolder) {
            $shownHolder.hide();
        }
        $shownHolder = divForRevisionId(revisionId);
        $shownHolder.show();
        window.location.hash = "r" + revisionForRevisionId(revisionId);
    };

    // Cache the focused row as it can be too slow to do AJS.$("tr.history-focus");
    var $focusedRow = undefined;
    var setRowFocus = function(revisionId) {
        if ($focusedRow) {
            $focusedRow.removeClass("history-focus");
        }
        $focusedRow = rowForRevisionId(revisionId);
        $focusedRow.addClass("history-focus");
    };

AJS.FE.fileHistoryPathLinkFn = function(event) {
    event.stopPropagation();
    return true;
};

AJS.FE.setFocusedRevision = function() {
    var location = document.location.hash;
    var revision;
    if (!location) {
        var $row = AJS.$("#history-table > tbody > tr:first");
        revision = revisionForRow($row);
    } else {
        // remove the '#r' from the anchor
        revision = location.substring(2);
    }
    var revisionId = revisionIdForRevision(revision);
    showRevisionDiv(revisionId);
    setRowFocus(revisionId);
    AJS.$("div.panel-content","#content").scrollTo(rowForRevisionId(revisionId));
    
    // setup local-link links
    AJS.$("a.local-link").live('click', function() {
        var href = AJS.$(this).attr("href");
        var revision = href.substring(href.lastIndexOf("#") + 2);
        var revisionId = revisionIdForRevision(revision);
        showRevisionDiv(revisionId);
        setRowFocus(revisionId);
    });
};

AJS.FE.extractRevisionDetailsSortKeys = function(cell) {
    var $node = AJS.$(cell);
    var $input = $node.children("input");
    if ($input.size() > 0) {
        return $input.val();
    } else {
        return $node.text();
    }
};
})();