if (!AJS.FECRU) {
    AJS.FECRU = {};
}
AJS.FECRU.HOVER = (function() {
    var opts = {
        onHover: true,
        showArrow: false,
        fadeTime: 200,
        hideDelay: 500,
        showDelay: 600,
        width: 300,
        offsetX: 10,
        offsetY: 2,
        container: "body",
        cacheContent:false,
        useLiveEvents : true
    };
    var __cache = {};
    var CACHE_FOREVER = -1;
    //todo: doc the create* function params
    var createDisplayHandler = function(createUrl, createCacheKey, createParams, minutesToCache, onAfterLoad, cachetype) {
        if (!cachetype) {
            cachetype = '__all';
        }
        return function ($contentDiv, mouseOverTrigger, showPopup) {
            var $trigger = AJS.$(mouseOverTrigger);
            var url = createUrl($trigger);
            var key = createCacheKey($trigger);
            var cache = __cache[cachetype] || {};
            var cacheHit = cache[key] || {isHit:false};
            var lastFetchTime = cacheHit.lastFetchTime || 0;
            var cacheTimedOut = (minutesToCache !== CACHE_FOREVER) && (new Date().getTime() - lastFetchTime) > (minutesToCache * 1000 * 60);
            if (key) {
                $contentDiv.data("targetToDisplay", {key:key});
                var error = function(xmlHttpRequest, textStatus, errorThrown) {
                    $contentDiv.html(escape(textStatus) + "<br>" + escape(errorThrown ? errorThrown : ""));
                };
                var done = function(resp) {
                    if (resp.worked) {
                        if ($contentDiv.data("targetToDisplay").key == key) {
                            $contentDiv.html(resp.html);
                            showPopup();
                            if (onAfterLoad) {
                                onAfterLoad();
                            }
                        }
                        cacheHit.resp = resp;
                        cacheHit.lastFetchTime = new Date().getTime();
                        cacheHit.isHit = true;
                        cache[key] = cacheHit;
                        __cache[cachetype] = cache;
                    } else {
                        $contentDiv.html('<div class="hoverpopup">' + resp.errorMsg + '</div>');
                    }
                };
                if ((!cacheHit.isHit) || cacheTimedOut) {
                    AJS.$.ajax({url: url,
                                data:createParams(key, $trigger),
                                type:"GET",
                                dataType:"json",
                                success: done,
                                error: error
                    });
                } else {
                    $contentDiv.html(cacheHit.resp.html);
                    showPopup();
                    if (onAfterLoad) {
                        onAfterLoad();
                    }
                }
            }
        };
    };

    var invalidateCache = function(type, key) {
            __cache[type] = undefined;
    };

    var addAllLinkPopups = function() {
        addJiraLinkPopups();
        addCruLinkPopups();
        linkUsers();
    };

    var addJiraLinkPopups = function() {
        var jiraShowDelay = 300;
        addLinkPopups("jiralinkspan", fishEyePageContext + '/json/action/issue-tooltip.do', jiraShowDelay, CACHE_FOREVER);
    };

    var addCruLinkPopups = function() {
        addLinkPopups("crulinkspan", fishEyePageContext + '/json/cru/tooltipdata', opts.showDelay, CACHE_FOREVER);
    };

    var addLinkPopups = function(linkSpanClass, url, showDelay, minutesToCache) {
        var createUrl = function() {
            return url;
        };
        var createCacheKey = function($trigger) {
            var $issueKeyLink = AJS.$("a", $trigger);
            var issueKey = $issueKeyLink.text();
            issueKey = AJS.$.trim(issueKey);
            return issueKey;
        };
        var createParams = function(key) {
            return {key:key};
        };
        var onAfterLoad = function() {
            // Rebind the dropdown menus.
            AJS.FECRU.UI.setDropdowns({selector: "#inline-dialog-crulinkspan-popup .aui-dd-parent"});
        };
        var displayHandler = createDisplayHandler(createUrl, createCacheKey, createParams, minutesToCache, onAfterLoad, linkSpanClass + "cache");
        var options = AJS.$.extend(false, opts, {showDelay: showDelay});
        AJS.InlineDialog("." + linkSpanClass, linkSpanClass + "-popup", displayHandler, options);
    };

    var linkUsers = function() {
        var createUrl = function($trigger) {
            return $trigger.attr('href');
        };
        var createParams = function() {
            return {ajax :"true"};
        };
        var createCacheKey = function($trigger) {
            var href = createUrl($trigger);
            return href;
        };
        var bindDropdownMenu = function() {
            AJS.FECRU.UI.setDropdowns();
        };

        var displayHandler = createDisplayHandler(createUrl, createCacheKey, createParams, CACHE_FOREVER, bindDropdownMenu, 'userlinks');
        AJS.InlineDialog("a.userorcommitter", "user-hover-inline-dialog", displayHandler, opts);
    };

    return {
        addAllLinkPopups: addAllLinkPopups,
        invalidateCache : invalidateCache
    };

})();
