create index idx_comment_defectApproved on COMMENT (defectApproved);
create index idx_comment_deleted on COMMENT (deleted);
create index idx_comment_user on COMMENT (USER_ID);
create index idx_comment_draft on COMMENT (draft);
create index idx_comment_defectRaised on COMMENT (defectRaised);
alter table COMMENT add constraint FK63717A3F1811CB9D foreign key (USER_ID) references USER;
alter table COMMENT add constraint FK63717A3FE71841CE foreign key (REVIEW_ID) references REVIEW;
alter table COMMENT add constraint FK63717A3F252D1475 foreign key (REPLY_TO_COMMENT_ID) references COMMENT;
alter table COMMENT_FIELD add constraint FKADAF9ADA999D94C6 foreign key (COMMENT_ID) references COMMENT;
alter table COMMENT_FIELD add constraint FKADAF9ADAA18837F5 foreign key (FIELD_ID) references FIELD;
alter table COMPLETED_FRX add constraint FKC51038F8BBB0C6CE foreign key (PARTICIPANT_ID) references REVIEW_PARTICIPANT;
alter table COMPLETED_FRX add constraint FKC51038F8D91F70A1 foreign key (FRX_ID) references FR_EXTRA;
create index proj_name_idx on CRUPROJECT (name);
create index proj_key_idx on CRUPROJECT (key);
alter table CRUPROJECT add constraint FK343E6733C0C9A9C foreign key (permissionScheme) references PERM_SCHEME;
alter table CRUPROJECT add constraint FK343E6739DDC2572 foreign key (defaultModerator) references USER;
alter table CRUPROJECT_ALWDREV add constraint FKA85AE77FA384A286 foreign key (PROJECT_ID) references CRUPROJECT;
alter table CRUPROJECT_ALWDREV add constraint FKA85AE77F1811CB9D foreign key (USER_ID) references USER;
alter table CRUPROJECT_ALWDREVGRP add constraint FKAAA288E6A384A286 foreign key (PROJECT_ID) references CRUPROJECT;
alter table CRUPROJECT_DEFREV add constraint FK6D3B6DCAA384A286 foreign key (PROJECT_ID) references CRUPROJECT;
alter table CRUPROJECT_DEFREV add constraint FK6D3B6DCA1811CB9D foreign key (USER_ID) references USER;
alter table CRUPROJECT_DEFREVGRP add constraint FK76CE5ABBA384A286 foreign key (PROJECT_ID) references CRUPROJECT;
create index idx_femsg_filerevision on FEINDEX_MSG (FR_ID);
create index idx_femsg_review on FEINDEX_MSG (REVIEW_ID);
alter table FEINDEX_MSG add constraint FK45E4075FE42B18C foreign key (FR_ID) references REVISION;
create index idx_field_scope on FIELD (fieldScope);
create index idx_field_name on FIELD (name);
alter table FR_DETAIL add constraint FKEA43C324F8701D39 foreign key (id) references REVISION;
create index idx_frx_fr on FR_EXTRA (fileRevision);
create index idx_frx_fromfr on FR_EXTRA (fromRevision);
create index idx_frx_review on FR_EXTRA (REVIEW_ID);
alter table FR_EXTRA add constraint FKFF633EBD547F95A3 foreign key (fromRevision) references REVISION;
alter table FR_EXTRA add constraint FKFF633EBD99758175 foreign key (fileRevision) references REVISION;
alter table FR_EXTRA add constraint FKFF633EBDE71841CE foreign key (REVIEW_ID) references REVIEW;
alter table INVITEES add constraint FK54488D77E71841CE foreign key (REVIEW_ID) references REVIEW;
create index notifiaction_review_idx on NOTIFICATION (review);
create index notification_ref2_idx on NOTIFICATION (ref2);
create index notification_ref1_idx on NOTIFICATION (ref1);
alter table NOTIFICATION add constraint FKAD9970EBBE1FB2F1 foreign key (actioner) references USER;
alter table NOTIFICATION add constraint FKAD9970EB92041DC4 foreign key (review) references REVIEW;
create index patch_review_idx on PATCH (review);
create index patch_ui_idx on PATCH (uploadItem);
alter table PATCH add constraint FK486282892041DC4 foreign key (review) references REVIEW;
alter table PATCH add constraint FK48628286408C046 foreign key (uploadItem) references UPLOAD;
alter table PATCH_REVISION add constraint FK7BE05E121710F81D foreign key (REVISION_ID) references REVISION;
alter table PATCH_REVISION add constraint FK7BE05E1257FBCB26 foreign key (PATCH_ID) references PATCH;
create index ps_name_idx on PERM_SCHEME (name);
alter table PS_ALL_USER add constraint FK5C45A285CF03846B foreign key (ps) references PERM_SCHEME;
alter table PS_ANON add constraint FK1AEE3388CF03846B foreign key (ps) references PERM_SCHEME;
alter table PS_GROUP add constraint FK432E9D23CF03846B foreign key (ps) references PERM_SCHEME;
alter table PS_REVIEW_ROLE add constraint FK97DB18C1CF03846B foreign key (ps) references PERM_SCHEME;
alter table PS_USER add constraint FK1AF75C87CF03846B foreign key (ps) references PERM_SCHEME;
create index recipient_email_idx on RECIPIENT (email);
create index recipient_rss_idx on RECIPIENT (rss);
create index recipient_uiack_idx on RECIPIENT (uiACK);
alter table RECIPIENT add constraint FKD6F981F9FAA6A011 foreign key (NOTIFICATION_ID) references NOTIFICATION;
alter table RECIPIENT add constraint FKD6F981F9210DC959 foreign key (user) references USER;
alter table REPLY add constraint FK4A41ACA4A6A205B foreign key (REPLY_ID) references COMMENT;
alter table REPLY add constraint FK4A41ACA999D94C6 foreign key (COMMENT_ID) references COMMENT;
alter table REVIEW add constraint FK8FE1EB58680499E foreign key (project) references CRUPROJECT;
alter table REVIEW add constraint FK8FE1EB585E255DBA foreign key (creator) references USER;
alter table REVIEW add constraint FK8FE1EB583D2C7EEE foreign key (parentReview) references REVIEW;
alter table REVIEW_COMMENT add constraint FKD84E3458E71841CE foreign key (REVIEW_ID) references REVIEW;
alter table REVIEW_COMMENT add constraint FKD84E3458999D94C6 foreign key (COMMENT_ID) references COMMENT;
alter table REVIEW_FIELD add constraint FK90C31533E71841CE foreign key (REVIEW_ID) references REVIEW;
alter table REVIEW_FIELD add constraint FK90C31533A18837F5 foreign key (FIELD_ID) references FIELD;
alter table REVIEW_PARTICIPANT add constraint FK936188ACE71841CE foreign key (REVIEW_ID) references REVIEW;
alter table REVIEW_PARTICIPANT add constraint FK936188AC210DC959 foreign key (user) references USER;
create index fr_name_idx on REVISION (revisionDisplayName);
create index fr_rev_idx on REVISION (revision);
create index fr_author_idx on REVISION (authorName);
create index fr_path_idx on REVISION (path);
create index fr_source_idx on REVISION (sourceName);
alter table REVISION add constraint FK1F1AA7DB6408C046 foreign key (uploadItem) references UPLOAD;
create index idx_rc_frx on REVISION_COMMENT (FRX_ID);
create index idx_rc_comment on REVISION_COMMENT (comment);
create index idx_rc_revision on REVISION_COMMENT (revision);
alter table REVISION_COMMENT add constraint FKD00FBDDBE8E4C7F9 foreign key (revision) references REVISION;
alter table REVISION_COMMENT add constraint FKD00FBDDBD91F70A1 foreign key (FRX_ID) references FR_EXTRA;
alter table REVISION_COMMENT add constraint FKD00FBDDB9CAB902A foreign key (comment) references COMMENT;
alter table REVPERMAID add constraint FK1DF5A649E71841CE foreign key (REVIEW_ID) references REVIEW;
create index scl_review_idx on STATE_CHANGE (reviewId);
create index scl_timestamp_idx on STATE_CHANGE (TIME_STAMP);
create index scl_superseded_idx on STATE_CHANGE (SUPERSEDED);
create index upload_user_idx on UPLOAD (user);
alter table UPLOAD add constraint FK95970201210DC959 foreign key (user) references USER;
create index idx_user_name on USER (userName);
create index cru_idx_star_name on cru_base_star_model (cru_user_name);
create index cru_idx_star_type on cru_base_star_model (cru_item_type);
create index cru_idx_comment_read_status_user on cru_comment_read_status (USER_ID);
create index cru_idx_comment_read_status_comment on cru_comment_read_status (COMMENT_ID);
alter table cru_comment_read_status add constraint FKC36175021811CB9D foreign key (USER_ID) references USER;
alter table cru_comment_read_status add constraint FKC3617502999D94C6 foreign key (COMMENT_ID) references COMMENT;
create index cru_idx_committer_mapping_user_name on cru_committer_user_mapping (user_name);

