
create index cru_idx_star_type on cru_base_star_model (cru_item_type);
create index idx_comment_defectApproved on cru_comment (cru_defect_approved);
create index idx_comment_deleted on cru_comment (cru_deleted);
create index idx_comment_user on cru_comment (cru_user_id);
create index idx_comment_draft on cru_comment (cru_draft);
create index idx_comment_defectRaised on cru_comment (cru_defect_raised);
alter table cru_comment add constraint FKE5A1D10644A616B5 foreign key (cru_review_id) references cru_review;
alter table cru_comment add constraint FKE5A1D106C50DAE44 foreign key (cru_user_id) references cru_user;
alter table cru_comment add constraint FKE5A1D10674DF349C foreign key (cru_reply_to_comment_id) references cru_comment;
alter table cru_comment_field add constraint FK44917881EDCA5CBF foreign key (cru_comment_id) references cru_comment;
alter table cru_comment_field add constraint FK449178819408AA2E foreign key (cru_field_id) references cru_field;
create index cru_idx_comment_read_status_user on cru_comment_read_status (USER_ID);
create index cru_idx_comment_read_status_comment on cru_comment_read_status (COMMENT_ID);
alter table cru_comment_read_status add constraint FKC36175021811CB9D foreign key (USER_ID) references cru_user;
alter table cru_comment_read_status add constraint FKC3617502999D94C6 foreign key (COMMENT_ID) references cru_comment;
create index cru_idx_committer_mapping_user_name on cru_committer_user_mapping (user_name);
alter table cru_completed_frx add constraint FK927E9E9F1BD6EA47 foreign key (cru_participant_id) references cru_review_participant;
alter table cru_completed_frx add constraint FK927E9E9F73591D1A foreign key (cru_frx_id) references cru_frx;
create index idx_femsg_filerevision on cru_feindex_msg (cru_fr_id);
create index idx_femsg_review on cru_feindex_msg (cru_review_id);
alter table cru_feindex_msg add constraint FKB56857DC665511F3 foreign key (cru_fr_id) references cru_revision;
create index idx_field_scope on cru_field (cru_field_scope);
create index idx_field_name on cru_field (cru_name);
alter table cru_fr_detail add constraint FK4F2200B487D2F44 foreign key (cru_revision_id) references cru_revision;
create index idx_frx_fr on cru_frx (cru_file_revision);
create index idx_frx_fromfr on cru_frx (cru_from_revision);
create index idx_frx_review on cru_frx (cru_review_id);
alter table cru_frx add constraint FK3E2EDB5344A616B5 foreign key (cru_review_id) references cru_review;
alter table cru_frx add constraint FK3E2EDB53D70B78C3 foreign key (cru_file_revision) references cru_revision;
alter table cru_frx add constraint FK3E2EDB537D43EA55 foreign key (cru_from_revision) references cru_revision;
alter table cru_invitees add constraint FK18230FB044A616B5 foreign key (cru_review_id) references cru_review;
create index notifiaction_review_idx on cru_notification (cru_review);
create index notification_ref2_idx on cru_notification (cru_ref2);
create index notification_ref1_idx on cru_notification (cru_ref1);
alter table cru_notification add constraint FK1F9536A42C3DCA3D foreign key (cru_review) references cru_review;
alter table cru_notification add constraint FK1F9536A4B0A0252A foreign key (cru_actioner) references cru_user;
create index patch_review_idx on cru_patch (cru_review);
create index patch_ui_idx on cru_patch (cru_uploadItem);
alter table cru_patch add constraint FK6E6A80AFB835883F foreign key (cru_uploadItem) references cru_upload_item;
alter table cru_patch add constraint FK6E6A80AF2C3DCA3D foreign key (cru_review) references cru_review;
alter table cru_patch_revision add constraint FKD573BD6B4A7C3D5F foreign key (cru_PATCH_ID) references cru_patch;
alter table cru_patch_revision add constraint FKD573BD6B487D2F44 foreign key (cru_revision_id) references cru_revision;
create index ps_name_idx on cru_perm_scheme (cru_name);
alter table cru_proj_allowed_grp add constraint FK893AB525F7B16A7F foreign key (cru_project_id) references cru_project;
alter table cru_proj_allowed_reviewer add constraint FK1E8211C5C50DAE44 foreign key (cru_user_id) references cru_user;
alter table cru_proj_allowed_reviewer add constraint FK1E8211C5F7B16A7F foreign key (cru_project_id) references cru_project;
alter table cru_proj_default_grp add constraint FK1502953EF7B16A7F foreign key (cru_project_id) references cru_project;
alter table cru_proj_default_reviewer add constraint FK3F4F594CC50DAE44 foreign key (cru_user_id) references cru_user;
alter table cru_proj_default_reviewer add constraint FK3F4F594CF7B16A7F foreign key (cru_project_id) references cru_project;
create index proj_name_idx on cru_project (cru_name);
create index proj_key_idx on cru_project (cru_proj_key);
alter table cru_project add constraint FK9A8C2DC0F2648A64 foreign key (cru_permission_scheme) references cru_perm_scheme;
alter table cru_project add constraint FK9A8C2DC0E2A633FC foreign key (cru_default_moderator) references cru_user;
alter table cru_ps_all_user add constraint FK830D758C7E705564 foreign key (cru_ps) references cru_perm_scheme;
alter table cru_ps_anon add constraint FK9B5B9A2F7E705564 foreign key (cru_ps) references cru_perm_scheme;
alter table cru_ps_group add constraint FKD06E0B7C7E705564 foreign key (cru_ps) references cru_perm_scheme;
alter table cru_ps_review_role add constraint FK8204BC3A7E705564 foreign key (cru_ps) references cru_perm_scheme;
alter table cru_ps_user add constraint FK9B64C32E7E705564 foreign key (cru_ps) references cru_perm_scheme;
create index recipient_email_idx on cru_recipient (cru_email);
create index recipient_rss_idx on cru_recipient (cru_rss);
create index recipient_uiack_idx on cru_recipient (cru_ui_ack);
alter table cru_recipient add constraint FK8E6F4700A88A4012 foreign key (cru_user) references cru_user;
alter table cru_recipient add constraint FK8E6F47009F44EBB8 foreign key (cru_notification_id) references cru_notification;
alter table cru_reply add constraint FK6E887351EDCA5CBF foreign key (cru_comment_id) references cru_comment;
alter table cru_reply add constraint FK6E8873513CEA9294 foreign key (cru_reply_id) references cru_comment;
alter table cru_review add constraint FK6288A3D17492E860 foreign key (cru_parent_review) references cru_review;
alter table cru_review add constraint FK6288A3D1B37C2C45 foreign key (cru_project) references cru_project;
alter table cru_review add constraint FK6288A3D1B214061 foreign key (cru_creator) references cru_user;
alter table cru_review_comment add constraint FKBE49D7F1EDCA5CBF foreign key (cru_comment_id) references cru_comment;
alter table cru_review_comment add constraint FKBE49D7F144A616B5 foreign key (cru_review_id) references cru_review;
alter table cru_review_field add constraint FKCC23C70C9408AA2E foreign key (cru_field_id) references cru_field;
alter table cru_review_field add constraint FKCC23C70C44A616B5 foreign key (cru_review_id) references cru_review;
alter table cru_review_participant add constraint FK54EBFC5A88A4012 foreign key (cru_user) references cru_user;
alter table cru_review_participant add constraint FK54EBFC544A616B5 foreign key (cru_review_id) references cru_review;
create index fr_name_idx on cru_revision (cru_revision_display_name);
create index fr_rev_idx on cru_revision (cru_revision);
create index fr_author_idx on cru_revision (cru_author_name);
create index fr_source_idx on cru_revision (cru_source_name);
alter table cru_revision add constraint FKE2F52A1434AAD25A foreign key (cru_path) references cru_stored_path;
alter table cru_revision add constraint FKE2F52A14E35E156A foreign key (cru_upload_item) references cru_upload_item;
create index idx_rc_frx on cru_revision_comment (cru_frx_id);
create index idx_rc_comment on cru_revision_comment (cru_comment);
create index idx_rc_revision on cru_revision_comment (cru_revision);
alter table cru_revision_comment add constraint FKB2B96B34DB653A32 foreign key (cru_revision) references cru_revision;
alter table cru_revision_comment add constraint FKB2B96B3473591D1A foreign key (cru_frx_id) references cru_frx;
alter table cru_revision_comment add constraint FKB2B96B3449A772D1 foreign key (cru_comment) references cru_comment;
alter table cru_revpermaid add constraint FK5538824244A616B5 foreign key (cru_review_id) references cru_review;
create index scl_review_idx on cru_state_change (cru_review_id);
create index scl_timestamp_idx on cru_state_change (cru_time_stamp);
create index scl_superseded_idx on cru_state_change (cru_superseded);
create index upload_user_idx on cru_upload_item (cru_user);
alter table cru_upload_item add constraint FK70E1F5B8A88A4012 foreign key (cru_user) references cru_user;
create index idx_user_name on cru_user (cru_userName);


