create table cru_base_star_model (cru_star_id integer not null, cru_item_type varchar(80) not null, cru_string_key1 varchar(255), cru_string_key2 varchar(255), cru_string_key3 varchar(255), cru_string_key4 varchar(255), cru_string_key5 varchar(255), cru_int_key1 integer, cru_int_key2 integer, cru_int_key3 integer, cru_int_key4 integer, cru_int_key5 integer, cru_text_key1 longvarchar, cru_text_key2 longvarchar, cru_user_name varchar(255), cru_date_created timestamp, cru_label varchar(255), primary key (cru_star_id));
create table cru_comment (cru_comment_id integer not null, cru_create_date timestamp, cru_message longvarchar not null, cru_draft bit not null, cru_deleted bit not null, cru_defect_raised bit not null, cru_defect_approved bit not null, cru_user_id integer, cru_review_id integer not null, cru_reply_to_comment_id integer, primary key (cru_comment_id));
create table cru_comment_field (cru_comment_id integer not null, cru_field_id integer not null, cru_field_order integer not null, primary key (cru_comment_id, cru_field_order));
create table cru_comment_read_status (cru_comment_read_status_id integer not null, cru_read bit not null, cru_user integer not null, cru_comment integer not null, primary key (cru_comment_read_status_id), unique (cru_user, cru_comment));
create table cru_committer_user_mapping (committer_name varchar(255) not null, repository_name varchar(255) not null, user_name varchar(255), primary key (committer_name, repository_name));
create table cru_completed_frx (cru_participant_id integer not null, cru_frx_id integer not null, primary key (cru_participant_id, cru_frx_id));
create table cru_feindex_msg (cru_id integer not null, cru_fr_id integer, cru_review_id integer not null, primary key (cru_id));
create table cru_field (cru_field_id integer not null, cru_config_version integer, cru_field_scope varchar(80), cru_name varchar(80), cru_string_val varchar(255), cru_int_val integer, cru_boolean_val bit, cru_date timestamp, primary key (cru_field_id));
create table cru_fr_detail (cru_revision_id integer not null, cru_value longvarchar, cru_name varchar(255) not null, primary key (cru_revision_id, cru_name));
create table cru_frx (cru_frx_id integer not null, cru_when_added timestamp, cru_reviewed integer, cru_further_action integer, cru_review_scope integer, cru_frx_order integer, cru_file_revision integer, cru_review_id integer not null, cru_from_revision integer, primary key (cru_frx_id), unique (cru_file_revision, cru_review_id));
create table cru_invitees (cru_review_id integer not null, cru_address varchar(255));
create table cru_logitem (cru_logitem_id integer not null, cru_create_date timestamp, cru_item longvarchar, primary key (cru_logitem_id));
create table cru_metric_definition (cru_metric_id integer not null, cru_xml longvarchar, primary key (cru_metric_id));
create table cru_notification (cru_notification_id integer not null, cru_note_type varchar(255) not null, cru_create_date timestamp, cru_actioner integer, cru_note longvarchar, cru_review integer, cru_ref1 integer, cru_ref2 integer, primary key (cru_notification_id));
create table cru_patch (cru_patch_id integer not null, cru_review integer, cru_uploadItem integer, primary key (cru_patch_id));
create table cru_patch_revision (cru_PATCH_ID integer not null, cru_revision_id integer not null, cru_revision_order integer not null, primary key (cru_PATCH_ID, cru_revision_order));
create table cru_perm_scheme (cru_ps_id integer not null, cru_name varchar(80), primary key (cru_ps_id), unique (cru_name));
create table cru_proj_allowed_grp (cru_project_id integer not null, cru_group_name varchar(255));
create table cru_proj_allowed_reviewer (cru_project_id integer not null, cru_user_id integer not null, primary key (cru_project_id, cru_user_id));
create table cru_proj_default_grp (cru_project_id integer not null, cru_group_name varchar(255));
create table cru_proj_default_reviewer (cru_project_id integer not null, cru_user_id integer not null, primary key (cru_project_id, cru_user_id));
create table cru_project (cru_project_id integer not null, cru_name varchar(80), cru_proj_key varchar(80), cru_default_repository_name varchar(255), cru_allow_reviewers_to_join bit, cru_store_revisions bit, cru_permission_scheme integer, cru_default_moderator integer, primary key (cru_project_id));
create table cru_ps_all_user (cru_ps integer not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_action_name));
create table cru_ps_anon (cru_ps integer not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_action_name));
create table cru_ps_group (cru_ps integer not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name));
create table cru_ps_review_role (cru_ps integer not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name));
create table cru_ps_user (cru_ps integer not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name));
create table cru_recipient (cru_recipient_id integer not null, cru_email integer, cru_rss integer, cru_ui_ack bit, cru_notification_id integer not null, cru_user integer, primary key (cru_recipient_id));
create table cru_reply (cru_comment_id integer not null, cru_reply_id integer not null, primary key (cru_comment_id, cru_reply_id));
create table cru_review (cru_review_id integer not null, cru_name varchar(255), cru_default_source varchar(80), cru_state varchar(80), cru_description longvarchar, cru_summary longvarchar, cru_allow_reviewer_to_join bit, cru_create_date timestamp, cru_metrics_version integer, cru_all_reviewers_complete bit, cru_parent_review integer, cru_creator integer, cru_project integer, primary key (cru_review_id));
create table cru_review_comment (cru_review_id integer not null, cru_comment_id integer not null, primary key (cru_review_id, cru_comment_id));
create table cru_review_field (cru_review_id integer not null, cru_field_id integer not null, cru_field_order integer not null, primary key (cru_review_id, cru_field_order));
create table cru_review_participant (cru_participant_id integer not null, cru_review_id integer not null, cru_user integer, cru_author bit, cru_moderator bit, cru_reviewer bit, cru_all_complete bit, cru_last_read timestamp, primary key (cru_participant_id), unique (cru_review_id, cru_user));
create table cru_revision (cru_revision_id integer not null, cru_create_date timestamp, cru_commit_date timestamp, cru_author_name varchar(255), cru_deletion bit, cru_file_type varchar(255), cru_source_name varchar(255), cru_path integer, cru_revision varchar(255), cru_revision_display_name varchar(255), cru_upload_item integer, primary key (cru_revision_id), unique (cru_source_name, cru_path, cru_revision));
create table cru_revision_comment (cru_rc_id integer not null, cru_create_date timestamp, cru_line_range varchar(255), cru_frx_id integer not null, cru_revision integer, cru_comment integer, primary key (cru_rc_id));
create table cru_revpermaid (cru_proj_key varchar(80) not null, cru_number integer not null, cru_review_id integer, primary key (cru_proj_key, cru_number));
create table cru_state_change (cru_id integer not null, cru_time_stamp timestamp, cru_superseded timestamp, cru_review_id integer, cru_new_state varchar(80), primary key (cru_id));
create table cru_stored_path (cru_path_id integer not null, cru_path varchar(1000), primary key (cru_path_id), unique (cru_path));
create table cru_upload_item (cru_upload_id integer not null, cru_create_date timestamp, cru_user integer, cru_description varchar(1000), cru_charset varchar(80), cru_original_name varchar(1000), cru_original_content_type varchar(80), primary key (cru_upload_id));
create table cru_user (cru_user_id integer not null, cru_userName varchar(255) not null, cru_dont_send__me_my_notes bit, cru_state_change_email_note integer, cru_comment_email_note integer, cru_reply_email_note integer, cru_general_email_note integer, cru_complete_email_note integer, primary key (cru_user_id), unique (cru_userName));
create table cru_version (cru_version_id integer not null, cru_version integer, primary key (cru_version_id));
insert into cru_version values (1,32);
