drop index cru_idx_comment_read_status_user if exists;
drop index cru_idx_comment_read_status_comment if exists;
alter table cru_comment_read_status drop constraint FKC36175021811CB9D;
alter table cru_comment_read_status drop constraint FKC3617502999D94C6;

alter table cru_comment_read_status alter column USER_ID rename to cru_user;
alter table cru_comment_read_status alter column COMMENT_ID rename to cru_comment; 

create index cru_idx_comment_read_status_user on cru_comment_read_status (cru_user);
create index cru_idx_comment_read_status_comment on cru_comment_read_status (cru_comment);
alter table cru_comment_read_status add constraint FKC3617502A88A4012 foreign key (cru_user) references cru_user;
alter table cru_comment_read_status add constraint FKC361750249A772D1 foreign key (cru_comment) references cru_comment;

drop table cru_base_star_model if exists;
create table cru_base_star_model (cru_star_id integer not null, cru_item_type varchar(80) not null, cru_string_key1 varchar(255), cru_string_key2 varchar(255), cru_string_key3 varchar(255), cru_string_key4 varchar(255), cru_string_key5 varchar(255), cru_int_key1 integer, cru_int_key2 integer, cru_int_key3 integer, cru_int_key4 integer, cru_int_key5 integer, cru_text_key1 longvarchar, cru_text_key2 longvarchar, cru_user_name varchar(255), cru_date_created timestamp, cru_label varchar(255), primary key (cru_star_id))
create index cru_idx_string_key5 on cru_base_star_model (cru_string_key5)
create index cru_idx_string_key4 on cru_base_star_model (cru_string_key4);
create index cru_idx_star_name on cru_base_star_model (cru_user_name);
create index cru_idx_int_key2 on cru_base_star_model (cru_int_key2);
create index cru_idx_string_key3 on cru_base_star_model (cru_string_key3);
create index cru_idx_int_key3 on cru_base_star_model (cru_int_key3);
create index cru_idx_string_key2 on cru_base_star_model (cru_string_key2);
create index cru_idx_int_key4 on cru_base_star_model (cru_int_key4);
create index cru_idx_string_key1 on cru_base_star_model (cru_string_key1);
create index cru_idx_int_key5 on cru_base_star_model (cru_int_key5);
create index cru_idx_int_key1 on cru_base_star_model (cru_int_key1);
create index cru_idx_star_type on cru_base_star_model (cru_item_type);

UPDATE cru_version SET cru_version = 32 WHERE cru_version_id = 1;
