create table cru_base_star_model (cru_star_id integer not null, cru_item_type varchar(80) not null, cru_string_key1 varchar(255), cru_string_key2 varchar(255), cru_string_key3 varchar(255), cru_string_key4 varchar(255), cru_string_key5 varchar(255), cru_int_key1 integer, cru_int_key2 integer, cru_int_key3 integer, cru_int_key4 integer, cru_int_key5 integer, cru_text_key1 text, cru_text_key2 text, cru_user_name varchar(255), cru_date_created bigint, cru_label varchar(255), primary key (cru_star_id)) type=InnoDB;
create table cru_comment (cru_comment_id integer not null, cru_create_date bigint, cru_message text not null, cru_draft bit not null, cru_deleted bit not null, cru_defect_raised bit not null, cru_comment_issue_key varchar(80), cru_defect_approved bit not null, cru_user_id integer, cru_review_id integer not null, cru_reply_to_comment_id integer, primary key (cru_comment_id)) type=InnoDB;
create table cru_comment_field (cru_comment_id integer not null, cru_field_id integer not null, cru_field_order integer not null, primary key (cru_comment_id, cru_field_order)) type=InnoDB;
create table cru_comment_read_status (cru_comment_read_status_id integer not null, cru_read bit not null, cru_user integer not null, cru_comment integer not null, primary key (cru_comment_read_status_id), unique (cru_user, cru_comment)) type=InnoDB;
create table cru_committer_user_mapping (cru_committer_name varchar(100) not null, cru_repository_name varchar(100) not null, cru_user_name varchar(255), primary key (cru_committer_name, cru_repository_name)) type=InnoDB;
create table cru_completed_frx (cru_participant_id integer not null, cru_frx_id integer not null, primary key (cru_participant_id, cru_frx_id)) type=InnoDB;
create table cru_content_root (cru_content_root_id integer not null, cru_content_root_rep varchar(100) not null, cru_content_root_path varchar(255) not null, cru_project integer not null, primary key (cru_content_root_id)) type=InnoDB;
create table cru_feindex_msg (cru_id integer not null, cru_fr_id integer, cru_review_id integer not null, primary key (cru_id)) type=InnoDB;
create table cru_field (cru_field_id integer not null, cru_config_version integer, cru_field_scope varchar(80), cru_name varchar(80), cru_string_val varchar(255), cru_int_val integer, cru_boolean_val bit, cru_date bigint, primary key (cru_field_id)) type=InnoDB;
create table cru_fr_detail (cru_revision_id integer not null, cru_value text, cru_name varchar(240) not null, primary key (cru_revision_id, cru_name)) type=InnoDB;
create table cru_frx (cru_frx_id integer not null, cru_when_added bigint, cru_reviewed integer, cru_further_action integer, cru_review_scope integer, cru_frx_order integer, cru_show_as_diff bit not null, cru_review_id integer not null, primary key (cru_frx_id)) type=InnoDB;
create table cru_frx_comment (cru_comment_id integer not null, cru_frx_id integer not null, primary key (cru_comment_id)) type=InnoDB;
create table cru_frx_revision (cru_frx_rev_id integer not null, cru_date_added bigint not null, cru_revision_order integer not null, cru_revision integer, cru_frx_id integer not null, primary key (cru_frx_rev_id)) type=InnoDB;
create table cru_inline_comment (cru_comment_id integer not null, cru_frx_id integer not null, primary key (cru_comment_id)) type=InnoDB;
create table cru_inline_comment_to_frx_revision (cru_ic_to_frx_rev_id integer not null, cru_line_range varchar(100) not null, cru_frx_rev_id integer not null, cru_inline_comment_id integer not null, primary key (cru_ic_to_frx_rev_id)) type=InnoDB;
create table cru_invitees (cru_review_id integer not null, cru_address varchar(255)) type=InnoDB;
create table cru_logitem (cru_logitem_id integer not null, cru_create_date bigint, cru_item text, primary key (cru_logitem_id)) type=InnoDB;
create table cru_metric_definition (cru_metric_id integer not null, cru_xml text, primary key (cru_metric_id)) type=InnoDB;
create table cru_notification (cru_notification_id integer not null, cru_note_type varchar(255) not null, cru_create_date bigint, cru_actioner integer, cru_note text, cru_review integer, cru_ref1 integer, cru_ref2 integer, primary key (cru_notification_id)) type=InnoDB;
create table cru_patch (cru_patch_id integer not null, cru_review integer, cru_upload_item integer, primary key (cru_patch_id)) type=InnoDB;
create table cru_patch_revision (cru_patch_id integer not null, cru_revision_id integer not null, cru_revision_order integer not null, primary key (cru_patch_id, cru_revision_order)) type=InnoDB;
create table cru_perm_scheme (cru_ps_id integer not null, cru_name varchar(80) unique, primary key (cru_ps_id)) type=InnoDB;
create table cru_proj_allowed_grp (cru_project_id integer not null, cru_group_name varchar(255)) type=InnoDB;
create table cru_proj_allowed_reviewer (cru_project_id integer not null, cru_user_id integer not null, primary key (cru_project_id, cru_user_id)) type=InnoDB;
create table cru_proj_default_grp (cru_project_id integer not null, cru_group_name varchar(255)) type=InnoDB;
create table cru_proj_default_reviewer (cru_project_id integer not null, cru_user_id integer not null, primary key (cru_project_id, cru_user_id)) type=InnoDB;
create table cru_project (cru_project_id integer not null, cru_name varchar(80), cru_proj_key varchar(80), cru_default_repository_name varchar(255), cru_allow_reviewers_to_join bit, cru_store_revisions bit, cru_default_duration integer, cru_permission_scheme integer, cru_default_moderator integer, primary key (cru_project_id)) type=InnoDB;
create table cru_ps_all_user (cru_ps integer not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_action_name)) type=InnoDB;
create table cru_ps_anon (cru_ps integer not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_action_name)) type=InnoDB;
create table cru_ps_group (cru_ps integer not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name)) type=InnoDB;
create table cru_ps_review_role (cru_ps integer not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name)) type=InnoDB;
create table cru_ps_user (cru_ps integer not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name)) type=InnoDB;
create table cru_recipient (cru_recipient_id integer not null, cru_email integer, cru_rss integer, cru_ui_ack bit, cru_user_notification_flag integer, cru_notification_id integer not null, cru_user integer, primary key (cru_recipient_id)) type=InnoDB;
create table cru_reply (cru_comment_id integer not null, cru_reply_id integer not null, primary key (cru_comment_id, cru_reply_id)) type=InnoDB;
create table cru_review (cru_review_id integer not null, cru_name varchar(255), cru_default_source varchar(80), cru_state varchar(80), cru_description text, cru_summary text, cru_allow_reviewer_to_join bit, cru_create_date bigint, cru_metrics_version integer, cru_all_reviewers_complete bit, cru_due_date bigint, cru_issue_key varchar(80), cru_parent_review integer, cru_creator integer, cru_project integer, primary key (cru_review_id)) type=InnoDB;
create table cru_review_comment (cru_review_id integer not null, cru_comment_id integer not null, primary key (cru_review_id, cru_comment_id)) type=InnoDB;
create table cru_review_field (cru_review_id integer not null, cru_field_id integer not null, cru_field_order integer not null, primary key (cru_review_id, cru_field_order)) type=InnoDB;
create table cru_review_participant (cru_participant_id integer not null, cru_review_id integer not null, cru_user integer, cru_author bit, cru_moderator bit, cru_reviewer bit, cru_all_complete bit, cru_last_read bigint, cru_status_change bigint, primary key (cru_participant_id), unique (cru_review_id, cru_user)) type=InnoDB;
create table cru_revision (cru_revision_id integer not null, cru_create_date bigint, cru_commit_date bigint, cru_author_name varchar(255), cru_deletion bit, cru_file_type varchar(15), cru_source_name varchar(100), cru_path integer, cru_revision varchar(100), cru_revision_display_name varchar(255), cru_upload_item integer, primary key (cru_revision_id), unique (cru_source_name, cru_path, cru_revision)) type=InnoDB;
create table cru_revpermaid (cru_proj_key varchar(80) not null, cru_number integer not null, cru_review_id integer, primary key (cru_proj_key, cru_number)) type=InnoDB;
create table cru_state_change (cru_id integer not null, cru_time_stamp bigint not null, cru_superseded bigint, cru_review_id integer not null, cru_new_state varchar(80) not null, cru_user integer not null, primary key (cru_id)) type=InnoDB;
create table cru_stored_path (cru_path_id integer not null, cru_path text, primary key (cru_path_id)) type=InnoDB;
create table cru_upload_item (cru_upload_id integer not null, cru_create_date bigint, cru_user integer, cru_description text, cru_charset varchar(80), cru_original_name text, cru_original_content_type varchar(80), primary key (cru_upload_id)) type=InnoDB;
create table cru_user (cru_user_id integer not null, cru_user_name varchar(255) not null unique, cru_dont_send_me_my_notes bit not null, cru_state_change_email_note integer not null, cru_comment_email_note integer not null, cru_reply_email_note integer not null, cru_general_email_note integer not null, cru_complete_email_note integer not null, cru_uncomplete_email_note integer not null, cru_uncomplete_on_defect bit not null, cru_uncomplete_on_revision_added bit not null, cru_review_page_view integer not null, primary key (cru_user_id)) type=InnoDB;
create table cru_version (cru_version_id integer not null, cru_version integer, primary key (cru_version_id)) type=InnoDB;
insert into cru_version values (1,43);