create table cru_base_star_model (cru_star_id int4 not null, cru_item_type varchar(80) not null, cru_string_key1 varchar(255), cru_string_key2 varchar(255), cru_string_key3 varchar(255), cru_string_key4 varchar(255), cru_string_key5 varchar(255), cru_int_key1 int4, cru_int_key2 int4, cru_int_key3 int4, cru_int_key4 int4, cru_int_key5 int4, cru_text_key1 text, cru_text_key2 text, cru_user_name varchar(255), cru_date_created int8, cru_label varchar(255), primary key (cru_star_id));
create table cru_comment (cru_comment_id int4 not null, cru_create_date int8, cru_message text not null, cru_draft bool not null, cru_deleted bool not null, cru_defect_raised bool not null, cru_comment_issue_key varchar(80), cru_defect_approved bool not null, cru_user_id int4, cru_review_id int4 not null, cru_reply_to_comment_id int4, primary key (cru_comment_id));
create table cru_comment_field (cru_comment_id int4 not null, cru_field_id int4 not null, cru_field_order int4 not null, primary key (cru_comment_id, cru_field_order));
create table cru_comment_read_status (cru_comment_read_status_id int4 not null, cru_read bool not null, cru_user int4 not null, cru_comment int4 not null, primary key (cru_comment_read_status_id), unique (cru_user, cru_comment));
create table cru_committer_user_mapping (cru_committer_name varchar(100) not null, cru_repository_name varchar(100) not null, cru_user_name varchar(255), primary key (cru_committer_name, cru_repository_name));
create table cru_completed_frx (cru_participant_id int4 not null, cru_frx_id int4 not null, primary key (cru_participant_id, cru_frx_id));
create table cru_content_root (cru_content_root_id int4 not null, cru_content_root_rep varchar(100) not null, cru_content_root_path varchar(255) not null, cru_project int4 not null, primary key (cru_content_root_id));
create table cru_feindex_msg (cru_id int4 not null, cru_fr_id int4, cru_review_id int4 not null, primary key (cru_id));
create table cru_field (cru_field_id int4 not null, cru_config_version int4, cru_field_scope varchar(80), cru_name varchar(80), cru_string_val varchar(255), cru_int_val int4, cru_boolean_val bool, cru_date int8, primary key (cru_field_id));
create table cru_fr_detail (cru_revision_id int4 not null, cru_value text, cru_name varchar(240) not null, primary key (cru_revision_id, cru_name));
create table cru_frx (cru_frx_id int4 not null, cru_when_added int8, cru_reviewed int4, cru_further_action int4, cru_review_scope int4, cru_frx_order int4, cru_show_as_diff bool not null, cru_review_id int4 not null, primary key (cru_frx_id));
create table cru_frx_comment (cru_comment_id int4 not null, cru_frx_id int4 not null, primary key (cru_comment_id));
create table cru_frx_revision (cru_frx_rev_id int4 not null, cru_date_added int8 not null, cru_revision_order int4 not null, cru_revision int4, cru_frx_id int4 not null, primary key (cru_frx_rev_id));
create table cru_inline_comment (cru_comment_id int4 not null, cru_frx_id int4 not null, primary key (cru_comment_id));
create table cru_inline_comment_to_frx_revision (cru_ic_to_frx_rev_id int4 not null, cru_line_range varchar(100) not null, cru_frx_rev_id int4 not null, cru_inline_comment_id int4 not null, primary key (cru_ic_to_frx_rev_id));
create table cru_invitees (cru_review_id int4 not null, cru_address varchar(255));
create table cru_logitem (cru_logitem_id int4 not null, cru_create_date int8, cru_item text, primary key (cru_logitem_id));
create table cru_metric_definition (cru_metric_id int4 not null, cru_xml text, primary key (cru_metric_id));
create table cru_notification (cru_notification_id int4 not null, cru_note_type varchar(255) not null, cru_create_date int8, cru_actioner int4, cru_note text, cru_review int4, cru_ref1 int4, cru_ref2 int4, primary key (cru_notification_id));
create table cru_patch (cru_patch_id int4 not null, cru_review int4, cru_upload_item int4, primary key (cru_patch_id));
create table cru_patch_revision (cru_patch_id int4 not null, cru_revision_id int4 not null, cru_revision_order int4 not null, primary key (cru_patch_id, cru_revision_order));
create table cru_perm_scheme (cru_ps_id int4 not null, cru_name varchar(80) unique, primary key (cru_ps_id));
create table cru_proj_allowed_grp (cru_project_id int4 not null, cru_group_name varchar(255));
create table cru_proj_allowed_reviewer (cru_project_id int4 not null, cru_user_id int4 not null, primary key (cru_project_id, cru_user_id));
create table cru_proj_default_grp (cru_project_id int4 not null, cru_group_name varchar(255));
create table cru_proj_default_reviewer (cru_project_id int4 not null, cru_user_id int4 not null, primary key (cru_project_id, cru_user_id));
create table cru_project (cru_project_id int4 not null, cru_name varchar(80), cru_proj_key varchar(80), cru_default_repository_name varchar(255), cru_allow_reviewers_to_join bool, cru_store_revisions bool, cru_default_duration int4, cru_permission_scheme int4, cru_default_moderator int4, primary key (cru_project_id));
create table cru_ps_all_user (cru_ps int4 not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_action_name));
create table cru_ps_anon (cru_ps int4 not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_action_name));
create table cru_ps_group (cru_ps int4 not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name));
create table cru_ps_review_role (cru_ps int4 not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name));
create table cru_ps_user (cru_ps int4 not null, cru_pid varchar(255) not null, cru_action_name varchar(80) not null, primary key (cru_ps, cru_pid, cru_action_name));
create table cru_recipient (cru_recipient_id int4 not null, cru_email int4, cru_rss int4, cru_ui_ack bool, cru_user_notification_flag int4, cru_notification_id int4 not null, cru_user int4, primary key (cru_recipient_id));
create table cru_reply (cru_comment_id int4 not null, cru_reply_id int4 not null, primary key (cru_comment_id, cru_reply_id));
create table cru_review (cru_review_id int4 not null, cru_name varchar(255), cru_default_source varchar(80), cru_state varchar(80), cru_description text, cru_summary text, cru_allow_reviewer_to_join bool, cru_create_date int8, cru_metrics_version int4, cru_all_reviewers_complete bool, cru_due_date int8, cru_issue_key varchar(80), cru_parent_review int4, cru_creator int4, cru_project int4, primary key (cru_review_id));
create table cru_review_comment (cru_review_id int4 not null, cru_comment_id int4 not null, primary key (cru_review_id, cru_comment_id));
create table cru_review_field (cru_review_id int4 not null, cru_field_id int4 not null, cru_field_order int4 not null, primary key (cru_review_id, cru_field_order));
create table cru_review_participant (cru_participant_id int4 not null, cru_review_id int4 not null, cru_user int4, cru_author bool, cru_moderator bool, cru_reviewer bool, cru_all_complete bool, cru_last_read int8, cru_status_change int8, primary key (cru_participant_id), unique (cru_review_id, cru_user));
create table cru_revision (cru_revision_id int4 not null, cru_create_date int8, cru_commit_date int8, cru_author_name varchar(255), cru_deletion bool, cru_file_type varchar(15), cru_source_name varchar(100), cru_path int4, cru_revision varchar(100), cru_revision_display_name varchar(255), cru_upload_item int4, primary key (cru_revision_id), unique (cru_source_name, cru_path, cru_revision));
create table cru_revpermaid (cru_proj_key varchar(80) not null, cru_number int4 not null, cru_review_id int4, primary key (cru_proj_key, cru_number));
create table cru_state_change (cru_id int4 not null, cru_time_stamp int8 not null, cru_superseded int8, cru_review_id int4 not null, cru_new_state varchar(80) not null, cru_user int4 not null, primary key (cru_id));
create table cru_stored_path (cru_path_id int4 not null, cru_path varchar(1000), primary key (cru_path_id));
create table cru_upload_item (cru_upload_id int4 not null, cru_create_date int8, cru_user int4, cru_description varchar(1000), cru_charset varchar(80), cru_original_name varchar(1000), cru_original_content_type varchar(80), primary key (cru_upload_id));
create table cru_user (cru_user_id int4 not null, cru_user_name varchar(255) not null unique, cru_dont_send_me_my_notes bool not null, cru_state_change_email_note int4 not null, cru_comment_email_note int4 not null, cru_reply_email_note int4 not null, cru_general_email_note int4 not null, cru_complete_email_note int4 not null, cru_uncomplete_email_note int4 not null, cru_uncomplete_on_defect bool not null, cru_uncomplete_on_revision_added bool not null, primary key (cru_user_id));
create table cru_version (cru_version_id int4 not null, cru_version int4, primary key (cru_version_id));
insert into cru_version values (1,42);