Subject: [${review.permaId}] ${review.stateName}: ${review.name}

<#-- @ftlvariable name="baseURL" type="java.lang.String" -->
<#-- @ftlvariable name="frxComments" type="java.util.List<com.cenqua.crucible.model.Comment>"-->
<#-- @ftlvariable name="review" type="com.cenqua.crucible.model.Review"-->
<#-- @ftlvariable name="commentManager" type="com.cenqua.crucible.model.managers.CommentManager"-->
<#if !notification?exists>
This is a list of all comments for ${review.permaId}.
</#if>
<#include "crucible-notification-header.ftl">
<#if notification?exists>
${notification.review.permaId} has been summarized and closed by ${notification.actioner.displayName}.
</#if>

Review Summary: ${review.summary?default("No summary")}
${review.precis}
<@render comments=review.comments prefix="General Comment by"/>

<@render comments=frxComments prefix="Revision Comment by"/>

<#include "crucible-notification-footer.ftl">

<#macro render comments prefix width=50>
<#assign prevFile = ""/>
<#list comments as comment >
<#if !comment.draft && !comment.deleted>
<#assign file = commentManager.getFilePath(comment)/>
<#if file != "" && file != prevFile>
<#assign prevFile = file/>
----------------------------------------
File: ${file}
</#if>
${prefix} ${comment.user.displayName} on ${comment.createDate?string("dd MMMM yyyy, HH:mm")} <#if comment.defectRaised>defect</#if>
${baseURL}cru/${review.permaId}/#c${comment.id}

${formatter.format(comment.message, width, "  ")}

<#list comment.comments as reply>
<#if !reply.draft && !reply.deleted>
  Reply by ${reply.user.displayName} on ${reply.createDate?string("dd MMMM yyyy, HH:mm")}
${formatter.format(reply.message, width-5, "  >  ")}

</#if>
</#list>
</#if>
</#list>
</#macro>
