function JAtom(xml) {
    this._parse(xml);
};

JAtom.prototype = {
    
    _parse: function(xml) {
    
        var channel = jQuery('feed', xml).eq(0);
        var thisFeed = this;
        this.version = '1.0';
        this.title = jQuery(channel).find('title:first').text();
        this.link = jQuery(channel).find('link:first').attr('href');
        this.description = jQuery(channel).find('subtitle:first').text();
        this.language = jQuery(channel).attr('xml:lang');
        this.updated = jQuery(channel).find('updated:first').text();
        
        this.items = new Array();
        
        var feed = this;
        
        jQuery('entry', xml).each( function() {
        
            var item = new JFeedItem();
            
            item.title = jQuery(this).find('title').eq(0).text();
            jQuery(this).find('link').each(function()
            {
                var rel = jQuery(this).attr("rel");
                var href = jQuery(this).attr("href");
                if (rel == "alternate")
                {
                    item.link = href;
                }
                else if (rel == "http://streams.atlassian.com/syndication/reply-to")
                {
                    item.replyTo = href;
                }
                else if (rel == "http://streams.atlassian.com/syndication/icon")
                {
                    item.icon = href;
                }
            });
            item.summary = jQuery(this).find('summary').eq(0).text();
            item.updated = jQuery(this).find('updated').eq(0).text();
            item.id = jQuery(this).find('id').eq(0).text();
            item.category = jQuery(this).find('category:first').attr("term");
            // JQuery doesn't support namespaces, so have to revert to DOM
            var inReplyTos = this.getElementsByTagNameNS("http://purl.org/syndication/thread/1.0", "in-reply-to");
            if (inReplyTos)
            {
                item.inReplyTo = jQuery(inReplyTos).attr("ref");                
            }
            jQuery(this).find("author").each( function() {
                item.authors.push(thisFeed._parsePerson(this));
            });
            var content = jQuery(this).find("content:first");
            item.action = thisFeed._getContentValue(content, "action");
            item.description = thisFeed._getContentValue(content, "description");
            item.linkingText = thisFeed._getContentValue(content, "linkingText");
            feed.items.push(item);
        });
    },
    _parsePerson: function(xml)
    {
        var person = new JFeedPerson();
        person.name = jQuery(xml).find('name').eq(0).text();
        person.email = jQuery(xml).find('email').eq(0).text();
        person.uri = jQuery(xml).find('uri').eq(0).text();
        person.username = jQuery(xml).find('username').eq(0).text();
        return person;
    },
    _getContentValue: function(content, name)
    {
        var element = content.find(name + ":first");
        if (element)
        {
            return element.text();
        }
        else
        {
            return "";
        }
    }
};

function JFeedItem() {
    this.authors = new Array();
};
JFeedItem.prototype = {
    title: '',
    link: '',
    summary: '',
    updated: '',
    id: '',
    category: '',
    inReplyTo: '',
    action: '',
    description: '',
    linkingText: '',
    replyTo: '',
    icon: ''
};

function JFeedPerson() {};
JFeedPerson.prototype = {
    name: '',
    email: '',
    uri: '',
    username: ''
};